
  MEMBER
_TBARDllMode_  EQUATE(0)
_TBARLinkMode_ EQUATE(1)
        MAP
GetTextProp     PROCEDURE(BCTypeClass SELF,STRING theValue, *UNSIGNED th, *UNSIGNED tw)
         MODULE('Windows')
Rectangle             PROCEDURE(UNSIGNED HDC, SIGNED x, SIGNED y, SIGNED x1, SIGNED y1),SIGNED,PASCAL
SelectObject          PROCEDURE(UNSIGNED HDC, UNSIGNED HGDIOBJ),UNSIGNED,PASCAL
         END
        END

DEBUG:CODE128     EQUATE(0)

    INCLUDE('Barcode.inc'),ONCE
    INCLUDE('PRNPROP.CLW'),ONCE
UPCE_Enc:DATA  GROUP
                  BYTE(00111000b)      !0 Number system 0
                  BYTE(00110100b)      !1       "
                  BYTE(00101100b)      !2       "
                  BYTE(00011100b)      !3       "
                  BYTE(00110010b)      !4       "
                  BYTE(00100110b)      !5       "
                  BYTE(00001110b)      !6       "
                  BYTE(00101010b)      !7       "
                  BYTE(00011010b)      !8       "
                  BYTE(00010110b)      !9       "
                  BYTE(00000111b)      !0 Number system 1
                  BYTE(00001011b)      !1       "
                  BYTE(00010011b)      !2       "
                  BYTE(00100011b)      !3       "
                  BYTE(00001101b)      !4       "
                  BYTE(00011001b)      !5       "
                  BYTE(00110001b)      !6       "
                  BYTE(00010101b)      !7       "
                  BYTE(00100101b)      !8       "
                  BYTE(00101001b)      !9       "
               END
UPCE_Enc       BYTE,DIM(20),OVER(UPCE_Enc:DATA)
EAN13Enc:DATA  GROUP
                  BYTE(00000000b)      !0  We only use the first 5 bits = 00000 = AAAAA
                  BYTE(00011010b)      !1                                 11010 = BBABA
                  BYTE(00010110b)      !2
                  BYTE(00001110b)      !3
                  BYTE(00011001b)      !4
                  BYTE(00010011b)      !5
                  BYTE(00000111b)      !6
                  BYTE(00010101b)      !7
                  BYTE(00001101b)      !8
                  BYTE(00001011b)      !9
               END
EAN13Enc       BYTE,DIM(10),OVER(EAN13Enc:DATA)

!------------------------------------------------------------------------------------------------------------
BCTypeClass.Init    PROCEDURE(BarcodeClass BC)
!------------------------------------------------------------------------------------------------------------
      CODE
   IF SELF.patternQ &= NULL
      SELF.patternQ &= NEW patternQ:TYPE
      ASSERT(~SELF.patternQ &= NULL)
   ELSE
      FREE(SELF.patternQ)
   END
   SELF.myBC &= BC
   SELF.SetPatterns
   RETURN FALSE

!------------------------------------------------------------------------------------------------------------
BCTypeClass.Kill    PROCEDURE
!------------------------------------------------------------------------------------------------------------
      CODE
   IF ~SELF.patternQ &= NULL
      FREE(SELF.patternQ)
      DISPOSE(SELF.patternQ)
      ASSERT(SELF.patternQ &= NULL)
   END
   RETURN FALSE

!------------------------------------------------------------------------------------------------------------
BCTypeClass.GetPattern           FUNCTION(BYTE c)
!------------------------------------------------------------------------------------------------------------
        CODE
   SELF.patternQ.asciiCode = c
   GET(SELF.patternQ,SELF.patternQ.AsciiCode)
   IF ERRORCODE()
      RETURN ''
   ELSE
      RETURN SELF.patternQ.pattern
   END

!------------------------------------------------------------------------------------------------------------
BCTypeClass.Draw    PROCEDURE(STRING bc_string)        !Draw barcode
!------------------------------------------------------------------------------------------------------------
        CODE
   RETURN FALSE

!------------------------------------------------------------------------------------------------------------
BCTypeClass.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
        CODE
    RETURN

!------------------------------------------------------------------------------------------------------------
BCTypeClass.DrawText             PROCEDURE(*STRING bc_string, UNSIGNED tw, UNSIGNED th)
!------------------------------------------------------------------------------------------------------------
CurrentX    SHORT
CurrentY    SHORT
        CODE
   CASE SELF.myBC.TextAlign
   OF 0
      CurrentX = SELF.myBC.obj{PROP:XPos} + (SELF.myBC.obj{PROP:Width} - tw) / 2
   OF 1
      CurrentX = SELF.myBC.obj{PROP:XPos}
   OF 2
      CurrentX = SELF.myBC.obj{PROP:XPos} + SELF.myBC.obj{PROP:Width} - tw
   END
   CurrentY = SELF.myBC.obj{PROP:YPos} + SELF.myBC.obj{PROP:Height} - th + 1   !go down some
   SETPENCOLOR(SELF.myBC.BarColor)
   SETFONT(0,SELF.myBC.myFont,SELF.myBC.myFontSize,SELF.myBC.BarColor,SELF.myBC.myFontStyle)
   SHOW(CurrentX,CurrentY,bc_string)
   RETURN FALSE

!------------------------------------------------------------------------------------------------------------
BCTypeClass.DrawBox              PROCEDURE(SHORT x, SHORT y, SHORT w, SHORT h, LONG bColor)
!------------------------------------------------------------------------------------------------------------
   CODE
   SETPENCOLOR(bColor)
   BOX(x,y,w,h,bcolor)
   RETURN
!------------------------------------------------------------------------------------------------------------
BCTypeClass.DrawLine             PROCEDURE(SHORT x, SHORT y, SHORT w, SHORT h, LONG bColor)
!------------------------------------------------------------------------------------------------------------
   CODE
   SETPENCOLOR(bColor)
   SETPENWIDTH(SELF.barWidth/SELF.myBC.ThousPerPixel)
   LINE(x,y,w,h)
   SETPENWIDTH(1)
   RETURN

!------------------------------------------------------------------------------------------------------------
BCTypeClass.DrawBox              PROCEDURE(REAL bw, LONG barColor)
!------------------------------------------------------------------------------------------------------------
x     SHORT
y     SHORT
w     SHORT
h     SHORT
        CODE
   IF SELF.myBC.isReport AND SELF.barWidth < (SELF.myBC.ThousPerPixel*3) !NOT SUPPORTED YET...In this case we need to use the API...
     !Rectangle(PRINTER{PROPPRINT:Device},10,10,400,500)
   ELSE
     IF SELF.myBC.BarAngle = 0
        IF ~SELF.isDrawStarted THEN SELF.xpos=SELF.myBC.obj{PROP:XPos}+SELF.myBC.ClearAreaLeft*SELF.BarWidth.
        x = SELF.xPos
        y = SELF.yPos
        w = SELF.barWidth * bw
        h = SELF.barHeight
        SELF.xPos += w
     ELSIF SELF.myBC.barAngle = 900
        IF ~SELF.isDrawStarted THEN SELF.xpos=SELF.myBC.obj{PROP:YPos}+SELF.myBC.obj{PROP:Height}-SELF.myBC.ClearAreaLeft*SELF.BarWidth-SELF.BarWidth.
        x = SELF.yPos                    !Start from the left
        y = SELF.xPos                    !..from the bottom up
        w = SELF.barHeight
        h = SELF.barWidth * bw
        SELF.xPos -= h
     ELSIF SELF.myBC.BarAngle = 1800
        IF ~SELF.isDrawStarted THEN SELF.xpos=SELF.myBC.obj{PROP:XPos}+SELF.myBC.obj{PROP:Width}-SELF.myBC.ClearAreaLeft*SELF.BarWidth.
        x = SELF.xPos
        y = SELF.yPos
        w = SELF.barWidth * bw
        h = SELF.barHeight
        SELF.xPos -= w
     ELSIF SELF.myBC.barAngle = 2700
        IF ~SELF.isDrawStarted THEN SELF.xpos=SELF.myBC.obj{PROP:YPos}+SELF.myBC.ClearAreaLeft*SELF.BarWidth.
        x = SELF.yPos                    !Start from the right
        y = SELF.xPos                    !..from the top down
        w = -SELF.barHeight
        h = SELF.barWidth * bw
        SELF.xPos += h
     END
     IF barColor = SELF.myBC.BackColor
        IF SELF.myBC.drawSpaces THEN SELF.DrawBox(x,y,w,h,barColor).
     ELSE
        SELF.DrawBox(x,y,w,h,barColor)
     END
   END
   SELF.isDrawStarted = TRUE
   RETURN

!------------------------------------------------------------------------------------------------------------
BCTypeClass.GetCheckDigit     PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
      CODE
   RETURN 0

!------------------------------------------------------------------------------------------------------------
BCTypeClass.SetDimensions     PROCEDURE(STRING bc_string, LONG pBarCount)
!------------------------------------------------------------------------------------------------------------
      CODE
   SELF.barCount = pBarCount
   SELF.myBC.obj{PROP:WIDTH}  = SELF.myBC.OriginalWidth   !First reset to original width
   SELF.myBC.obj{PROP:HEIGHT} = SELF.myBC.OriginalHeight  !...and height
   IF SELF.myBC.BarAngle = 0 OR SELF.myBC.BarAngle = 1800
     !(1) Calculate the bar width
     IF SELF.myBC.isReport  !REPORT (in THOUS)
       IF SELF.myBC.xWidth                                  !..Force an xWidth (THOUS or Pixels)
          SELF.barWidth = SELF.myBC.ThousPerPixel * (SELF.myBC.xWidth / SELF.myBC.ThousPerPixel) !calculate THOUS
       ELSE
          SELF.barWidth = SELF.myBC.obj{PROP:Width}/SELF.barCount   !..space between bars
          SELF.barWidth = SELF.myBC.ThousPerPixel * (SELF.barWidth / SELF.myBC.ThousPerPixel) !calculate THOUS
       END
       !IF SELF.barWidth < SELF.myBC.ThousPerPixel THEN SELF.barWidth = SELF.myBC.ThousPerPixel.   !At LEAST printer min...
       IF SELF.barWidth < SELF.myBC.ThousPerPixel*3 THEN SELF.barWidth = SELF.myBC.ThousPerPixel*3.  !So rectangle works..
     ELSE                   !WINDOW (in PIXELS)
       IF SELF.myBC.xWidth                                  !..Force an xWidth (THOUS or Pixels)
         IF SELF.myBC.ForcePixels                           !..if xWidth is in pixels
           SELF.barWidth = SELF.myBC.xWidth                 !....already given in pixels...
         ELSE                                               !..otherwise,
           SELF.barWidth = SELF.myBC.xWidth / SELF.myBC.ThousPerPixel !....calculate how pixels that is....
         END
       ELSE
         SELF.barWidth = SELF.myBC.obj{PROP:Width}/SELF.barCount   !..space between bars
       END
       IF SELF.barWidth < 1 THEN SELF.barWidth = 1.        !But it has to be at LEAST 1
     END
     SELF.myBC.obj{PROP:WIDTH} = SELF.barCount * SELF.barWidth  !Reprocess the control width
     SELF.myBC.Width = SELF.myBC.obj{PROP:WIDTH}         !save current width
     !
     !(2) Calculate the text properties
     IF SELF.myBC.DrawText
        GetTextprop(SELF,bc_string,SELF.th,SELF.tw)
     END
     !
     !(3) Calculate the bar height
     IF SELF.myBC.BarAngle = 0
        SELF.yPos = SELF.myBC.obj{PROP:YPos}
     ELSIF SELF.myBC.BarAngle = 1800
        SELF.yPos = SELF.myBC.obj{PROP:YPos} + SELF.myBC.obj{PROP:Height}
     END
     IF SELF.myBC.DrawText
        SELF.barHeight = SELF.myBC.obj{PROP:Height} - SELF.th     !leave space for text...
     ELSE
        SELF.barHeight = SELF.myBC.obj{PROP:Height} - 1
     END
   ELSIF SELF.myBC.BarAngle = 900 OR SELF.myBC.BarAngle = 2700
     !(1) Calculate the bar width (actually for these angels is the height)
     IF SELF.myBC.isReport  !REPORT (in THOUS)
       IF SELF.myBC.xWidth                                  !..Force an xWidth (THOUS or Pixels)
          SELF.barWidth = SELF.myBC.ThousPerPixel * (SELF.myBC.xWidth / SELF.myBC.ThousPerPixel) !calculate THOUS
       ELSE
          SELF.barWidth = SELF.myBC.obj{PROP:Height}/SELF.barCount   !..space between bars
          SELF.barWidth = SELF.myBC.ThousPerPixel * (SELF.barWidth / SELF.myBC.ThousPerPixel) !calculate THOUS
       END
       !IF SELF.barWidth < SELF.myBC.ThousPerPixel THEN SELF.barWidth = SELF.myBC.ThousPerPixel.   !At LEAST printer min...
       IF SELF.barWidth < SELF.myBC.ThousPerPixel*3 THEN SELF.barWidth = SELF.myBC.ThousPerPixel*3.  !So rectangle works..
     ELSE                   !WINDOW (in PIXELS)
       IF SELF.myBC.xWidth                                  !..Force an xWidth (THOUS or Pixels)
         IF SELF.myBC.ForcePixels                           !..if xWidth is in pixels
           SELF.barWidth = SELF.myBC.xWidth                 !....already given in pixels...
         ELSE                                               !..otherwise,
           SELF.barWidth = SELF.myBC.xWidth / SELF.myBC.ThousPerPixel !....calculate how pixels that is....
         END
       ELSE
         SELF.barWidth = SELF.myBC.obj{PROP:Height}/SELF.barCount   !..space between bars
       END
       IF SELF.barWidth < 1 THEN SELF.barWidth = 1.        !But it has to be at LEAST 1
     END
     SELF.myBC.obj{PROP:HEIGHT} = SELF.barCount * SELF.barWidth  !Reprocess the control width
     SELF.myBC.Height = SELF.myBC.obj{PROP:HEIGHT}       !save current height
     !
     !(2) Calculate the text properties
     IF SELF.myBC.DrawText
        GetTextprop(SELF,bc_string,SELF.th,SELF.tw)
     END
     !
     !(3) Calculate the bar height (i.e. for this angles corresponds to the width)
     IF SELF.myBC.BarAngle = 900          !Start from the left
        SELF.yPos = SELF.myBC.obj{PROP:XPos}
     ELSIF SELF.myBC.BarAngle = 2700      !Start from the right
        SELF.yPos = SELF.myBC.obj{PROP:XPos} + SELF.myBC.obj{PROP:Width}
     END
     IF SELF.myBC.DrawText
        SELF.barHeight = SELF.myBC.obj{PROP:Width} - SELF.tw     !leave space for text...
     ELSE
        SELF.barHeight = SELF.myBC.obj{PROP:Width}
     END
   END
   SELF.isDrawStarted = FALSE


!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: CODE39 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
CODE39.Draw    PROCEDURE(STRING theString)        !Draw CODE39 barcode
!------------------------------------------------------------------------------------------------------------
narrowCount SHORT             !Total number of narrow bars we need to print
wideCount   SHORT             !..total number of wide bars we need to print
barCount    REAL              !Equivalent number of narrow bars...
c           BYTE              !character ASCII code
bc_string  STRING(255)
bc_pattern  CSTRING(15)
n           SHORT
i           SHORT
j           SHORT
L:PrintStartDigit BYTE(0)        !Should we print the start and end digits '*'?
L:PrintEndDigit   BYTE(0)        !..print them if they were sent in the string to encode...

      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed)
   IF SELF.myBC.BCType = BARCODE:CODE39
       theString = UPPER(theString)           !Make sure only uppercase
   END
   j = LEN(CLIP(theString))
   IF theString[1] = '*'                      !Received start digit (remove it)
       L:PrintStartDigit = TRUE
       IF theString[j] = '*'                  !..received end digit
          L:PrintEndDigit = TRUE
          theString = theString[i+1 : j-1]    !....remove both (they'll be added by procedure
       ELSE                                   !..no, only received the start digit
          theString = theString[i+1 : j]      !....remove that only
   .   .
   IF SELF.myBC.AddCheckDigit       !If using check digit, add it now...
       theString = CLIP(theString) & CHR(SELF.GetCheckDigit(theString))
   END
   bc_string = '<201>' & CLIP(theString) & '<202>'          !add pre-amble, post-amble
   !
   !(3) Before anything, calculate how many BARs we need.  Loop through all characters
   !    in barcode summing into variable "barCount" the total number of bars
   narrowCount = 1                                             !
   wideCount = 0
   LOOP n = 1 To LEN(CLIP(bc_string))
       c = VAL(bc_string[n])
       IF SELF.myBC.BCType = BARCODE:CODE39 AND (c > 90 AND c<>201 AND c<>202) THEN c=0.
       bc_pattern = SELF.GetPattern(c)
       LOOP i = 1 To LEN(CLIP(bc_pattern))
         CASE bc_pattern[i]
         OF ' '
            narrowCount += 1
         OF '1'
            narrowCount += 2
         OF '2'
            narrowCount += 1
            wideCount   += 1
         END
       END
   END
   narrowCount += SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight
   barCount = narrowCount + wideCount * SELF.myBC.Wide2NarrowRatio
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5)  Build pattern string...
   !Not needed for CODE39
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !(7) Now draw each character in barcode string
   LOOP n = 1 To LEN(CLIP(bc_string))
      c = VAL(bc_string[n])
      IF SELF.myBC.BCType = BARCODE:CODE39 AND (c > 90 AND c<>201 AND c<>202) THEN c=0.
      bc_pattern = SELF.GetPattern(c)

      !draw each bar
      LOOP i = 1 To LEN(CLIP(bc_pattern))
         CASE bc_pattern[i]
         OF ' '      !space
            SELF.DrawBox(1,SELF.myBC.BackColor)
         OF '1'      !space+narrow line
            SELF.DrawBox(1,SELF.myBC.BackColor)
            SELF.DrawBox(1,SELF.myBC.BarColor)
         OF '2'      !space+wide line
            SELF.DrawBox(1,SELF.myBC.BackColor)
            SELF.DrawBox(SELF.myBC.Wide2NarrowRatio,SELF.myBC.BarColor)
         ELSE
            MESSAGE('Error in the draw pattern')
         END
      END
   END
   !
   !(9) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       IF SELF.myBC.PrintStartStop           !Forces writing start and end digit...
          L:PrintStartDigit = TRUE
          L:PrintEndDigit   = TRUE
       END
       IF L:PrintStartDigit
          theString = '*' & theString
       END
       IF L:PrintEndDigit
          theString = CLIP(theString) & '*'
       END
       SELF.DrawText(theString,SELF.tw,SELF.th)
   END
   !
   !
   !(10) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN FALSE         !No trouble
!
!
!
!------------------------------------------------------------------------------------------------------------
CODE39.GetCheckDigit     PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
i           LONG
Count       LONG
chkDigit    BYTE
q           &patternQ:TYPE
      CODE
   q &= SELF.patternQ
   Count = 0
   LOOP i=1 TO LEN(CLIP(bc_string))
      q.asciicode = VAL(bc_string[i])
      GET(q,q.asciicode)
      IF ERRORCODE()
         MESSAGE('Invalid code in barcode: ' & bc_string[i])
      ELSE
         Count += q.value
      END
   END
   chkDigit = Count % 43
   q.value = chkDigit
   GET(q,q.Value)
   IF ERRORCODE()
      MESSAGE('Invalid check digit: ' & chkDigit)
      RETURN 0
   ELSE
      RETURN q.asciicode
   END
!
!
!
!------------------------------------------------------------------------------------------------------------
CODE39.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 201 ;q.pattern = '1 1221';  ADD(q,q.asciiCode)      !pre-amble
    q.asciiCode = 202 ;q.pattern = '1 1221';  ADD(q,q.asciiCode)      !post-amble
                                                                                         !digits
    q.asciiCode = 48; q.pattern = '11 221'; q.value = 0;  ADD(q,q.asciiCode)        !0
    q.asciiCode = 49; q.pattern = '21 112'; q.value = 1;  ADD(q,q.asciiCode)        !1
    q.asciiCode = 50; q.pattern = '12 112'; q.value = 2;  ADD(q,q.asciiCode)        !2
    q.asciiCode = 51; q.pattern = '22 111'; q.value = 3;  ADD(q,q.asciiCode)
    q.asciiCode = 52; q.pattern = '11 212'; q.value = 4;  ADD(q,q.asciiCode)
    q.asciiCode = 53; q.pattern = '21 211'; q.value = 5;  ADD(q,q.asciiCode)
    q.asciiCode = 54; q.pattern = '12 211'; q.value = 6;  ADD(q,q.asciiCode)
    q.asciiCode = 55; q.pattern = '11 122'; q.value = 7;  ADD(q,q.asciiCode)
    q.asciiCode = 56; q.pattern = '21 121'; q.value = 8;  ADD(q,q.asciiCode)
    q.asciiCode = 57; q.pattern = '12 121'; q.value = 9;  ADD(q,q.asciiCode)
                                                                                         !capital letters
    q.asciiCode = 65; q.pattern = '211 12'; q.value =10;  ADD(q,q.asciiCode)        !A
    q.asciiCode = 66; q.pattern = '121 12'; q.value =11;  ADD(q,q.asciiCode)        !B
    q.asciiCode = 67; q.pattern = '221 11'; q.value =12;  ADD(q,q.asciiCode)        !C
    q.asciiCode = 68; q.pattern = '112 12'; q.value =13;  ADD(q,q.asciiCode)        !D
    q.asciiCode = 69; q.pattern = '212 11'; q.value =14;  ADD(q,q.asciiCode)        !E
    q.asciiCode = 70; q.pattern = '122 11'; q.value =15;  ADD(q,q.asciiCode)        !F
    q.asciiCode = 71; q.pattern = '111 22'; q.value =16;  ADD(q,q.asciiCode)        !G
    q.asciiCode = 72; q.pattern = '211 21'; q.value =17;  ADD(q,q.asciiCode)        !H
    q.asciiCode = 73; q.pattern = '121 21'; q.value =18;  ADD(q,q.asciiCode)        !I
    q.asciiCode = 74; q.pattern = '112 21'; q.value =19;  ADD(q,q.asciiCode)        !J
    q.asciiCode = 75; q.pattern = '2111 2'; q.value =20;  ADD(q,q.asciiCode)        !K
    q.asciiCode = 76; q.pattern = '1211 2'; q.value =21;  ADD(q,q.asciiCode)        !L
    q.asciiCode = 77; q.pattern = '2211 1'; q.value =22;  ADD(q,q.asciiCode)        !M
    q.asciiCode = 78; q.pattern = '1121 2'; q.value =23;  ADD(q,q.asciiCode)        !N
    q.asciiCode = 79; q.pattern = '2121 1'; q.value =24;  ADD(q,q.asciiCode)        !O
    q.asciiCode = 80; q.pattern = '1221 1'; q.value =25;  ADD(q,q.asciiCode)        !P
    q.asciiCode = 81; q.pattern = '1112 2'; q.value =26;  ADD(q,q.asciiCode)        !Q
    q.asciiCode = 82; q.pattern = '2112 1'; q.value =27;  ADD(q,q.asciiCode)        !R
    q.asciiCode = 83; q.pattern = '1212 1'; q.value =28;  ADD(q,q.asciiCode)        !S
    q.asciiCode = 84; q.pattern = '1122 1'; q.value =29;  ADD(q,q.asciiCode)        !T
    q.asciiCode = 85; q.pattern = '2 1112'; q.value =30;  ADD(q,q.asciiCode)        !U
    q.asciiCode = 86; q.pattern = '1 2112'; q.value =31;  ADD(q,q.asciiCode)        !V
    q.asciiCode = 87; q.pattern = '2 2111'; q.value =32;  ADD(q,q.asciiCode)        !W
    q.asciiCode = 88; q.pattern = '1 1212'; q.value =33;  ADD(q,q.asciiCode)        !X
    q.asciiCode = 89; q.pattern = '2 1211'; q.value =34;  ADD(q,q.asciiCode)        !Y
    q.asciiCode = 90; q.pattern = '1 2211'; q.value =35;  ADD(q,q.asciiCode)        !Z
                                                                                       !Misc
    q.asciiCode = 32; q.pattern = '1 2121'  ; q.value =38;ADD(q,q.asciiCode)     !space
    q.asciiCode = 36; q.pattern = '1 1 1 11'; q.value =39;ADD(q,q.asciiCode)     !$
    q.asciiCode = 37; q.pattern = '11 1 1 1'; q.value =42;ADD(q,q.asciiCode)     !%
    q.asciiCode = 43; q.pattern = '1 11 1 1'; q.value =41;ADD(q,q.asciiCode)     !+
    q.asciiCode = 45; q.pattern = '1 1122'  ; q.value =36;ADD(q,q.asciiCode)     !-
    q.asciiCode = 47; q.pattern = '1 1 11 1'; q.value =40;ADD(q,q.asciiCode)     !/
    q.asciiCode = 46; q.pattern = '2 1121'  ; q.value =37;ADD(q,q.asciiCode)     !.
    q.asciiCode = 65; q.pattern = '1 1221'  ; q.value =0 ;ADD(q,q.asciiCode)     !* -> start&stop character
!   q.asciiCode = 35; q.pattern = ''        ; q.value =0 ;ADD(q,q.asciiCode)     !# cannot do!
!   q.asciiCode = 64; q.pattern = ''        ; q.value =0 ;ADD(q,q.asciiCode)     !@ cannot do!
    SORT(q,q.value)
!
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: CODE39x ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
CODE39x.Init    PROCEDURE(BarcodeClass BC)
!------------------------------------------------------------------------------------------------------------
      CODE
   IF SELF.CODE39xQ &= NULL
      SELF.CODE39xQ &= NEW CODE39x:TYPE
      ASSERT(~SELF.CODE39xQ &= NULL)
   END
   RETURN PARENT.Init(BC)

!------------------------------------------------------------------------------------------------------------
CODE39x.Kill    PROCEDURE
!------------------------------------------------------------------------------------------------------------
      CODE
   IF ~SELF.CODE39xQ &= NULL
      FREE(SELF.CODE39xQ)
      DISPOSE(SELF.CODE39xQ)
      ASSERT(SELF.CODE39xQ &= NULL)
   END
   RETURN PARENT.Kill()

!------------------------------------------------------------------------------------------------------------
CODE39x.GetPattern           FUNCTION(BYTE c)
!------------------------------------------------------------------------------------------------------------
rtnPattern     STRING(20)
i              BYTE
        CODE
   SELF.CODE39xQ.asciicode = c
   GET(SELF.CODE39xQ,SELF.CODE39xQ.asciicode)
   IF ERRORCODE()
      RETURN(PARENT.GetPattern(c))
   ELSE
      LOOP i=1 TO LEN(SELF.CODE39xQ.CODE39chars)      !loop through each character...
         ASSERT(i < 3)  !otherwise it was an error
         rtnPattern = CLIP(rtnPattern) & PARENT.GetPattern(VAL(SELF.CODE39xQ.CODE39chars[i]))
      END
   END
   RETURN rtnPattern

!------------------------------------------------------------------------------------------------------------
CODE39x.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &CODE39x:TYPE
        CODE
!The regular Code 39 barcode symbology supports only 43 characters. If you wish to encode
!other ASCII characters then 'Extended Code 39' must be used.
!Extended Code 39 obtains the additional characters by combining two regular Code 39
!characters, the barcode decoder interprets the character pair as a single ASCII character.
!The table below lists the pairs required to encode the whole 128 ASCII character set.
!For example if you wished to encode the ASCII BEL character <7> you would use the $G pair.
!The barcode decoder will interpret $G as a BEL.
!Many characters retain their original encoding- SPACE, all numerics and all Capital Alpha
!characters.
!Lower case Alpha, control and most symbol characters MUST be encoded.
!The 4 characters % $ / + NEED not be encoded UNLESS they are followed by an Alphabetic
!character. However we feel it better to encode these characters to avoid potential errors in
!decoding where subsequent editing of the character field might produce an ambiguous combination.
   q &= SELF.CODE39xQ
   IF RECORDS(q) THEN FREE(q).
   q.asciicode = 0   ;q.CODE39chars = '%U'; ADD(q,q.asciicode)
   q.asciicode = 1   ;q.CODE39chars = '$A'; ADD(q,q.asciicode)
   q.asciicode = 2   ;q.CODE39chars = '$B'; ADD(q,q.asciicode)
   q.asciicode = 3   ;q.CODE39chars = '$C'; ADD(q,q.asciicode)
   q.asciicode = 4   ;q.CODE39chars = '$D'; ADD(q,q.asciicode)
   q.asciicode = 5   ;q.CODE39chars = '$E'; ADD(q,q.asciicode)
   q.asciicode = 6   ;q.CODE39chars = '$F'; ADD(q,q.asciicode)
   q.asciicode = 7   ;q.CODE39chars = '$G'; ADD(q,q.asciicode)
   q.asciicode = 8   ;q.CODE39chars = '$H'; ADD(q,q.asciicode)
   q.asciicode = 9   ;q.CODE39chars = '$I'; ADD(q,q.asciicode)
   q.asciicode = 10  ;q.CODE39chars = '$J'; ADD(q,q.asciicode)
   q.asciicode = 11  ;q.CODE39chars = '$K'; ADD(q,q.asciicode)
   q.asciicode = 12  ;q.CODE39chars = '$L'; ADD(q,q.asciicode)
   q.asciicode = 13  ;q.CODE39chars = '$M'; ADD(q,q.asciicode)
   q.asciicode = 14  ;q.CODE39chars = '$N'; ADD(q,q.asciicode)
   q.asciicode = 15  ;q.CODE39chars = '$O'; ADD(q,q.asciicode)
   q.asciicode = 16  ;q.CODE39chars = '$P'; ADD(q,q.asciicode)
   q.asciicode = 17  ;q.CODE39chars = '$Q'; ADD(q,q.asciicode)
   q.asciicode = 18  ;q.CODE39chars = '$R'; ADD(q,q.asciicode)
   q.asciicode = 19  ;q.CODE39chars = '$S'; ADD(q,q.asciicode)
   q.asciicode = 20  ;q.CODE39chars = '$T'; ADD(q,q.asciicode)
   q.asciicode = 21  ;q.CODE39chars = '$U'; ADD(q,q.asciicode)
   q.asciicode = 22  ;q.CODE39chars = '$V'; ADD(q,q.asciicode)
   q.asciicode = 23  ;q.CODE39chars = '$W'; ADD(q,q.asciicode)
   q.asciicode = 24  ;q.CODE39chars = '$X'; ADD(q,q.asciicode)
   q.asciicode = 25  ;q.CODE39chars = '$Y'; ADD(q,q.asciicode)
   q.asciicode = 26  ;q.CODE39chars = '$Z'; ADD(q,q.asciicode)
   q.asciicode = 27  ;q.CODE39chars = '%A'; ADD(q,q.asciicode)
   q.asciicode = 28  ;q.CODE39chars = '%B'; ADD(q,q.asciicode)
   q.asciicode = 29  ;q.CODE39chars = '%C'; ADD(q,q.asciicode)
   q.asciicode = 30  ;q.CODE39chars = '%D'; ADD(q,q.asciicode)
   q.asciicode = 31  ;q.CODE39chars = '%E'; ADD(q,q.asciicode)
   q.asciicode = 32  ;q.CODE39chars = ' ' ; ADD(q,q.asciicode)
   q.asciicode = 33  ;q.CODE39chars = '/A'; ADD(q,q.asciicode)
   q.asciicode = 34  ;q.CODE39chars = '/B'; ADD(q,q.asciicode)
   q.asciicode = 35  ;q.CODE39chars = '/C'; ADD(q,q.asciicode)
   q.asciicode = 36  ;q.CODE39chars = '/D'; ADD(q,q.asciicode)            !'$' see above
   q.asciicode = 37  ;q.CODE39chars = '/E'; ADD(q,q.asciicode)            !'%' see above
   q.asciicode = 38  ;q.CODE39chars = '/F'; ADD(q,q.asciicode)
   q.asciicode = 39  ;q.CODE39chars = '/G'; ADD(q,q.asciicode)
   q.asciicode = 40  ;q.CODE39chars = '/H'; ADD(q,q.asciicode)
   q.asciicode = 41  ;q.CODE39chars = '/I'; ADD(q,q.asciicode)
   q.asciicode = 42  ;q.CODE39chars = '/J'; ADD(q,q.asciicode)
   q.asciicode = 43  ;q.CODE39chars = '/K'; ADD(q,q.asciicode)            !'+' see above
   q.asciicode = 44  ;q.CODE39chars = '/L'; ADD(q,q.asciicode)
   q.asciicode = 45  ;q.CODE39chars = '-' ; ADD(q,q.asciicode)            !could be '/M'
   q.asciicode = 46  ;q.CODE39chars = '.' ; ADD(q,q.asciicode)            !could be '/N'
   q.asciicode = 47  ;q.CODE39chars = '/O'; ADD(q,q.asciicode)            !'/' see above
   q.asciicode = 48  ;q.CODE39chars = '0' ; ADD(q,q.asciicode)            !could be '/P'
   q.asciicode = 49  ;q.CODE39chars = '1' ; ADD(q,q.asciicode)            !could be '/Q'
   q.asciicode = 50  ;q.CODE39chars = '2' ; ADD(q,q.asciicode)            !could be '/R'
   q.asciicode = 51  ;q.CODE39chars = '3' ; ADD(q,q.asciicode)            !could be '/S'
   q.asciicode = 52  ;q.CODE39chars = '4' ; ADD(q,q.asciicode)            !could be '/T'
   q.asciicode = 53  ;q.CODE39chars = '5' ; ADD(q,q.asciicode)            !could be '/U'
   q.asciicode = 54  ;q.CODE39chars = '6' ; ADD(q,q.asciicode)            !could be '/V'
   q.asciicode = 55  ;q.CODE39chars = '7' ; ADD(q,q.asciicode)            !could be '/W'
   q.asciicode = 56  ;q.CODE39chars = '8' ; ADD(q,q.asciicode)            !could be '/X'
   q.asciicode = 57  ;q.CODE39chars = '9' ; ADD(q,q.asciicode)            !could be '/Y'
   q.asciicode = 58  ;q.CODE39chars = '/Z'; ADD(q,q.asciicode)
   q.asciicode = 59  ;q.CODE39chars = '%F'; ADD(q,q.asciicode)
   q.asciicode = 60  ;q.CODE39chars = '%G'; ADD(q,q.asciicode)
   q.asciicode = 61  ;q.CODE39chars = '%H'; ADD(q,q.asciicode)
   q.asciicode = 62  ;q.CODE39chars = '%I'; ADD(q,q.asciicode)
   q.asciicode = 63  ;q.CODE39chars = '%J'; ADD(q,q.asciicode)
   q.asciicode = 64  ;q.CODE39chars = '%V'; ADD(q,q.asciicode)
   q.asciicode = 65  ;q.CODE39chars = 'A' ; ADD(q,q.asciicode)
   q.asciicode = 66  ;q.CODE39chars = 'B' ; ADD(q,q.asciicode)
   q.asciicode = 67  ;q.CODE39chars = 'C' ; ADD(q,q.asciicode)
   q.asciicode = 68  ;q.CODE39chars = 'D' ; ADD(q,q.asciicode)
   q.asciicode = 69  ;q.CODE39chars = 'E' ; ADD(q,q.asciicode)
   q.asciicode = 70  ;q.CODE39chars = 'F' ; ADD(q,q.asciicode)
   q.asciicode = 71  ;q.CODE39chars = 'G' ; ADD(q,q.asciicode)
   q.asciicode = 72  ;q.CODE39chars = 'H' ; ADD(q,q.asciicode)
   q.asciicode = 73  ;q.CODE39chars = 'I' ; ADD(q,q.asciicode)
   q.asciicode = 74  ;q.CODE39chars = 'J' ; ADD(q,q.asciicode)
   q.asciicode = 75  ;q.CODE39chars = 'K' ; ADD(q,q.asciicode)
   q.asciicode = 76  ;q.CODE39chars = 'L' ; ADD(q,q.asciicode)
   q.asciicode = 77  ;q.CODE39chars = 'M' ; ADD(q,q.asciicode)
   q.asciicode = 78  ;q.CODE39chars = 'N' ; ADD(q,q.asciicode)
   q.asciicode = 79  ;q.CODE39chars = 'O' ; ADD(q,q.asciicode)
   q.asciicode = 80  ;q.CODE39chars = 'P' ; ADD(q,q.asciicode)
   q.asciicode = 81  ;q.CODE39chars = 'Q' ; ADD(q,q.asciicode)
   q.asciicode = 82  ;q.CODE39chars = 'R' ; ADD(q,q.asciicode)
   q.asciicode = 83  ;q.CODE39chars = 'S' ; ADD(q,q.asciicode)
   q.asciicode = 84  ;q.CODE39chars = 'T' ; ADD(q,q.asciicode)
   q.asciicode = 85  ;q.CODE39chars = 'U' ; ADD(q,q.asciicode)
   q.asciicode = 86  ;q.CODE39chars = 'V' ; ADD(q,q.asciicode)
   q.asciicode = 87  ;q.CODE39chars = 'W' ; ADD(q,q.asciicode)
   q.asciicode = 88  ;q.CODE39chars = 'X' ; ADD(q,q.asciicode)
   q.asciicode = 89  ;q.CODE39chars = 'Y' ; ADD(q,q.asciicode)
   q.asciicode = 90  ;q.CODE39chars = 'Z' ; ADD(q,q.asciicode)
   q.asciicode = 91  ;q.CODE39chars = '%K'; ADD(q,q.asciicode)
   q.asciicode = 92  ;q.CODE39chars = '%L'; ADD(q,q.asciicode)
   q.asciicode = 93  ;q.CODE39chars = '%M'; ADD(q,q.asciicode)
   q.asciicode = 94  ;q.CODE39chars = '%N'; ADD(q,q.asciicode)
   q.asciicode = 95  ;q.CODE39chars = '%O'; ADD(q,q.asciicode)
   q.asciicode = 96  ;q.CODE39chars = '%W'; ADD(q,q.asciicode)
   q.asciicode = 97  ;q.CODE39chars = '+A'; ADD(q,q.asciicode)
   q.asciicode = 98  ;q.CODE39chars = '+B'; ADD(q,q.asciicode)
   q.asciicode = 99  ;q.CODE39chars = '+C'; ADD(q,q.asciicode)
   q.asciicode =100  ;q.CODE39chars = '+D'; ADD(q,q.asciicode)
   q.asciicode =101  ;q.CODE39chars = '+E'; ADD(q,q.asciicode)
   q.asciicode =102  ;q.CODE39chars = '+F'; ADD(q,q.asciicode)
   q.asciicode =103  ;q.CODE39chars = '+G'; ADD(q,q.asciicode)
   q.asciicode =104  ;q.CODE39chars = '+H'; ADD(q,q.asciicode)
   q.asciicode =105  ;q.CODE39chars = '+I'; ADD(q,q.asciicode)
   q.asciicode =106  ;q.CODE39chars = '+J'; ADD(q,q.asciicode)
   q.asciicode =107  ;q.CODE39chars = '+K'; ADD(q,q.asciicode)
   q.asciicode =108  ;q.CODE39chars = '+L'; ADD(q,q.asciicode)
   q.asciicode =109  ;q.CODE39chars = '+M'; ADD(q,q.asciicode)
   q.asciicode =110  ;q.CODE39chars = '+N'; ADD(q,q.asciicode)
   q.asciicode =111  ;q.CODE39chars = '+O'; ADD(q,q.asciicode)
   q.asciicode =112  ;q.CODE39chars = '+P'; ADD(q,q.asciicode)
   q.asciicode =113  ;q.CODE39chars = '+Q'; ADD(q,q.asciicode)
   q.asciicode =114  ;q.CODE39chars = '+R'; ADD(q,q.asciicode)
   q.asciicode =115  ;q.CODE39chars = '+S'; ADD(q,q.asciicode)
   q.asciicode =116  ;q.CODE39chars = '+T'; ADD(q,q.asciicode)
   q.asciicode =117  ;q.CODE39chars = '+U'; ADD(q,q.asciicode)
   q.asciicode =118  ;q.CODE39chars = '+V'; ADD(q,q.asciicode)
   q.asciicode =119  ;q.CODE39chars = '+W'; ADD(q,q.asciicode)
   q.asciicode =120  ;q.CODE39chars = '+X'; ADD(q,q.asciicode)
   q.asciicode =121  ;q.CODE39chars = '+Y'; ADD(q,q.asciicode)
   q.asciicode =122  ;q.CODE39chars = '+Z'; ADD(q,q.asciicode)
   q.asciicode =123  ;q.CODE39chars = '%P'; ADD(q,q.asciicode)
   q.asciicode =124  ;q.CODE39chars = '%Q'; ADD(q,q.asciicode)
   q.asciicode =125  ;q.CODE39chars = '%R'; ADD(q,q.asciicode)
   q.asciicode =126  ;q.CODE39chars = '%S'; ADD(q,q.asciicode)
   q.asciicode =127  ;q.CODE39chars = '%T'; ADD(q,q.asciicode)       !DEL %T --Also... %X %Y and %Z decode as DEL
   PARENT.SetPatterns           !Read CODE39 patterns...
!
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: CODE128 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
CODE128.Init    PROCEDURE(BarcodeClass BC)
!------------------------------------------------------------------------------------------------------------
      CODE
   IF SELF.CODE128Q &= NULL
      SELF.CODE128Q &= NEW CODE128:TYPE
      ASSERT(~SELF.CODE128Q &= NULL)
   END
   SELF.myBC &= BC
   SELF.SetPatterns
   RETURN FALSE

!------------------------------------------------------------------------------------------------------------
CODE128.Kill    PROCEDURE
!------------------------------------------------------------------------------------------------------------
      CODE
   IF ~SELF.CODE128Q &= NULL
      FREE(SELF.CODE128Q)
      DISPOSE(SELF.CODE128Q)
      ASSERT(SELF.CODE128Q &= NULL)
   END
   RETURN FALSE
!
!------------------------------------------------------------------------------------------------------------
CODE128.Draw    PROCEDURE(STRING bc_string)        !Draw CODE128 barcode
!------------------------------------------------------------------------------------------------------------
barCount    SHORT             !Total number of bars we need to print
bc_pattern  CSTRING(15)
i           LONG
j           LONG
isBar       BYTE(TRUE)
BCq         CODE128BC:TYPE
      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed)
   !
   !(3) Before anything, calculate how many BARs we need.  Loop through all characters
   !    in barcode summing into variable "barCount" the total number of bars
   SELF.BCq &= BCq
   SELF.BuildBC(bc_string)          !Check digit is mandatory, but is not printed....
   !IF SELF.myBC.DrawText AND SELF.myBC.WriteCheckDigit  !Write check digit too...ELR
   !    bc_string = CLIP(bc_string) & CHR(SELF.GetCheckDigit(bc_string))
   !END
   barCount = RECORDS(BCq)
   barCount = 11*barCount + 2       !All have 11 modules except the last one which has two more...
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !(5)  Build pattern string...(not neede here)
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !(7) Now draw each character in barcode string
   LOOP i=1 TO RECORDS(BCq)
       GET(BCq,i)
       bc_pattern = SELF.GetPattern(BCq.value)
       !draw each bar
       LOOP j = 1 To LEN(CLIP(bc_pattern))
         CASE bc_pattern[j]
         OF '1'
            SELF.DrawBox(1,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
         OF '2'
            SELF.DrawBox(2,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
         OF '3'
            SELF.DrawBox(3,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
         OF '4'
            SELF.DrawBox(4,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
         END   !CASE bc_pattern[i]
         isBar = BXOR(isBar,1)
       END     !LOOP i TO LEN(CLIP(bc_pattern))
   END         !LOOP n TO LEN(CLIP(bc_string))
   !
   !
   !(8) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !(9) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   SELF.BCq &= NULL           !Clear before we leave, because local queue will be destroyed...
   RETURN FALSE
!
!
!------------------------------------------------------------------------------------------------------------
CODE128.GetPattern           FUNCTION(BYTE c)
!------------------------------------------------------------------------------------------------------------
rtnPattern     STRING(20)
i              BYTE
        CODE
   SELF.CODE128Q.value = c
   GET(SELF.CODE128Q,SELF.CODE128Q.value)
   IF ERRORCODE()
      RETURN ''
   ELSE
      RETURN SELF.CODE128Q.pattern
   END
!
!
!------------------------------------------------------------------------------------------------------------
CODE128.BuildBC              PROCEDURE(*STRING bc_string)
!------------------------------------------------------------------------------------------------------------
i              LONG
j              LONG
k              LONG
a              BYTE
b              BYTE
c              BYTE
q              &CODE128BC:TYPE

    COMPILE('DEBUG',DEBUG:CODE128)
DBGWindow WINDOW('Codes'),AT(,,117,186),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,GRAY
       LIST,AT(4,2,106,170),USE(?List),VSCROLL,FORMAT('28L(3)|~Set~L(7)@n4@20L(3)|~Value~L(1)@n4@')
       STRING('<<<<<<#'),AT(87,175),USE(?DBGTotal)
     END
    !DEBUG

        CODE
   q &= SELF.BCq
   j  = LEN(CLIP(bc_string))
   If Self.myBC.BCType = BARCODE:CODE128C then
        If j % 2 > 0 Then
            j += 1
            bc_string = '0' & bc_string
        End
   End
   LOOP i = 1 TO j
      DO TakeNext
   END
   i = SELF.GetCheckDigit('')            ! check digit.
   q.value = i; ADD(q)                   !..and write check digit code, and finally
   q.value = 106; ADD(q)                 !..the End code

   COMPILE('DEBUG',DEBUG:CODE128)
   IF ~SELF.myBC.isReport
      OPEN(DBGWindow)
      ?List{PROP:From} = q
      ?DBGTotal{PROP:Text} = RECORDS(q)
      ACCEPT.
      CLOSE(DBGWindow)
   END
   !DEBUG
   RETURN

TakeNext       ROUTINE
   IF SELF.myBC.BCType = BARCODE:CODE128
      DO ChkA
      DO ChkB
      DO ChkC
      IF ((q.set=0 OR q.set=3) AND c) OR |                     !Starting or in C
         (c >= 6) OR |                                         !Large number of letters
         (c >= 4 AND b>a AND q.set=1) OR |
         (c >= 4 AND a>b AND q.set=2)
         DO AddC
      ELSIF b > a OR ((q.set=0 OR q.set=2 OR q.set=3) AND b >= a)
         DO AddB
      ELSIF a > b OR ((q.set=0 OR q.set=1) AND a >= b)
         DO AddA
      ELSE
         MESSAGE('something is wrong in BuildBC....')
      END
   ELSIF SELF.myBC.BCType = BARCODE:CODE128A
      a = 1
      DO AddA
   ELSIF SELF.myBC.BCType = BARCODE:CODE128B
      b = 1
      DO AddB
   ELSIF SELF.myBC.BCType = BARCODE:CODE128C
      c = 1
      DO AddC
   END

ChkA        ROUTINE
   a = 0
   k = i-1
   LOOP
      k += 1
      IF k > j THEN EXIT.                                !Done....
      SELF.CODE128Q.codeA = bc_string[k]                 !Check character
      GET(SELF.CODE128Q,SELF.CODE128Q.codeA)             !
      IF ERRORCODE() THEN EXIT.                          !
      a += 1                                             !One more TYPE A
   END

ChkB        ROUTINE
   b = 0                                                 !
   k = i-1
   LOOP
      k += 1
      IF k > j THEN EXIT.                                !Done....
      SELF.CODE128Q.codeB = bc_string[k]                 !Check
      GET(SELF.CODE128Q,SELF.CODE128Q.codeB)             !
      IF ERRORCODE() THEN EXIT.                          !
      b += 1                                             !One more TYPE B
   END

ChkC        ROUTINE
   c = 0                                                 !
   k = i-1
   LOOP
      k += 1
      IF k >= j THEN EXIT.
      SELF.CODE128Q.codeC = bc_string[k : k+1]           !Check pair
      GET(SELF.CODE128Q,SELF.CODE128Q.codeC)             !
      IF ERRORCODE() THEN EXIT.                          !
      k += 1
      c += 2                                             !Two more TYPE C
   END

AddA        ROUTINE
   CASE q.set
   OF 0
      q.set=1;q.value=103;ADD(q)
   OF 2
!omitted because not too sure it will generate shorter codes for most cases...
!      IF a=1                                            !Only one A
!         q.set=2;q.value=98;ADD(q)                      !..SHIFT to A
!         SELF.CODE128Q.codeA = bc_string[i]
!         GET(SELF.CODE128Q,SELF.CODE128Q.codeA)         !..get the data
!         IF ERRORCODE() THEN MESSAGE('Something is wrong with SHIFT_A operation...').
!         q.set=1; q.value=SELF.CODE128Q.value; ADD(q)   !..and add it to A
!         q.set=2                                        !BUT LEAVE in B
!         EXIT
!      ELSE                                              !otherwise,
         q.set=2;q.value=101;ADD(q)                     !..Change to A
!      END
   OF 3
      q.set=3;q.value=101;ADD(q)                        !Change to A
   END
   LOOP k=1 TO a
      SELF.CODE128Q.codeA = bc_string[i+k-1]
      GET(SELF.CODE128Q,SELF.CODE128Q.codeA)
      IF ERRORCODE() THEN CYCLE.
      q.set=1; q.value=SELF.CODE128Q.value; ADD(q)
   END
   i += a-1

AddB        ROUTINE
   CASE q.set
   OF 0
      q.set=2;q.value=104;ADD(q)
   OF 1
!      IF b=1                                            !Only one B
!         q.set=1;q.value=98;ADD(q)                      !..SHIFT to B
!         SELF.CODE128Q.codeB = bc_string[i]
!         GET(SELF.CODE128Q,SELF.CODE128Q.codeB)         !..get the data
!         IF ERRORCODE() THEN MESSAGE('Something is wrong with SHIFT_B operation...').
!         q.set=2; q.value=SELF.CODE128Q.value; ADD(q)   !..Add it to B
!         q.set=1                                        !BUT LEAVE in A
!         EXIT
!      ELSE                                              !otherwise,
         q.set=1;q.value=100;ADD(q)                     !..Change to B
!      END
   OF 3
      q.set=3;q.value=100;ADD(q)                        !Change to B
   END
   LOOP k=1 TO b
      SELF.CODE128Q.codeB = bc_string[i+k-1]
      GET(SELF.CODE128Q,SELF.CODE128Q.codeB)
      IF ERRORCODE() THEN CYCLE.
      q.set=2; q.value=SELF.CODE128Q.value; ADD(q)
   END
   i += b-1


AddC        ROUTINE
   CASE q.set
   OF 0
      q:set=3;q.value=105;ADD(q) !Start C
   OF 1
      q.set=1;q.value=99;ADD(q)  !Change to C
   OF 2
      q.set=2;q.value=99;ADD(q)  !Change to C
   END
   LOOP k=1 TO c
      SELF.CODE128Q.codeC = bc_string[i+k-1 : i+k]
      GET(SELF.CODE128Q,SELF.CODE128Q.codeC)
      IF ERRORCODE() THEN CYCLE.
      q.set=3; q.value=SELF.CODE128Q.value; ADD(q)
      k += 1
   END
   i += 1

!
!
!------------------------------------------------------------------------------------------------------------
CODE128.GetCheckDigit     PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
i           LONG
Count       LONG
chkDigit    BYTE
      CODE
   GET(SELF.BCq,1)
   Count = SELF.BCq.Value
   LOOP i=2 TO RECORDS(SELF.BCq)
      GET(SELF.BCq,i)
      Count += (i-1) * SELF.BCq.Value
   END
   chkDigit = Count % 103     !the remainder after dividing by 103...
   RETURN chkDigit
!
!
!------------------------------------------------------------------------------------------------------------
CODE128.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &CODE128:TYPE
        CODE
    q &= SELF.CODE128Q
    IF RECORDS(q) THEN FREE(q).
!NOTES:
! <201>=FNC 1, <202>=FNC 2, <203>=FNC 3, <204>=FNC 4
! <240>=SHIFT
! <241>=CODE A, <242>=CODE B, <243>=CODE C
! <251>=START A, <252>=START B, <253>=START C
! <255>=STOP
  q.value=  0; q.codeA= ' '   ; q.codeB= ' '    ; q.codeC= '00'; q.pattern= '212222' ; ADD(q)
  q.value=  1; q.codeA= '!'   ; q.codeB= '!'    ; q.codeC= '01'; q.pattern= '222122' ; ADD(q)
  q.value=  2; q.codeA= '"'   ; q.codeB= '"'    ; q.codeC= '02'; q.pattern= '222221' ; ADD(q)
  q.value=  3; q.codeA= '#'   ; q.codeB= '#'    ; q.codeC= '03'; q.pattern= '121223' ; ADD(q)
  q.value=  4; q.codeA= '$'   ; q.codeB= '$'    ; q.codeC= '04'; q.pattern= '121322' ; ADD(q)
  q.value=  5; q.codeA= '%'   ; q.codeB= '%'    ; q.codeC= '05'; q.pattern= '131222' ; ADD(q)
  q.value=  6; q.codeA= '&'   ; q.codeB= '&'    ; q.codeC= '06'; q.pattern= '122213' ; ADD(q)
  q.value=  7; q.codeA= '<34>'; q.codeB= '<34>' ; q.codeC= '07'; q.pattern= '122312' ; ADD(q)
  q.value=  8; q.codeA= '('   ; q.codeB= '('    ; q.codeC= '08'; q.pattern= '132212' ; ADD(q)
  q.value=  9; q.codeA= ')'   ; q.codeB= ')'    ; q.codeC= '09'; q.pattern= '221213' ; ADD(q)
  q.value= 10; q.codeA= '*'   ; q.codeB= '*'    ; q.codeC= '10'; q.pattern= '221312' ; ADD(q)
  q.value= 11; q.codeA= '+'   ; q.codeB= '+'    ; q.codeC= '11'; q.pattern= '231212' ; ADD(q)
  q.value= 12; q.codeA= ','   ; q.codeB= ','    ; q.codeC= '12'; q.pattern= '112232' ; ADD(q)
  q.value= 13; q.codeA= '-'   ; q.codeB= '-'    ; q.codeC= '13'; q.pattern= '122132' ; ADD(q)
  q.value= 14; q.codeA= '.'   ; q.codeB= '.'    ; q.codeC= '14'; q.pattern= '122231' ; ADD(q)
  q.value= 15; q.codeA= '/'   ; q.codeB= '/'    ; q.codeC= '15'; q.pattern= '113222' ; ADD(q)
  q.value= 16; q.codeA= '0'   ; q.codeB= '0'    ; q.codeC= '16'; q.pattern= '123122' ; ADD(q)
  q.value= 17; q.codeA= '1'   ; q.codeB= '1'    ; q.codeC= '17'; q.pattern= '123221' ; ADD(q)
  q.value= 18; q.codeA= '2'   ; q.codeB= '2'    ; q.codeC= '18'; q.pattern= '223211' ; ADD(q)
  q.value= 19; q.codeA= '3'   ; q.codeB= '3'    ; q.codeC= '19'; q.pattern= '221132' ; ADD(q)
  q.value= 20; q.codeA= '4'   ; q.codeB= '4'    ; q.codeC= '20'; q.pattern= '221231' ; ADD(q)
  q.value= 21; q.codeA= '5'   ; q.codeB= '5'    ; q.codeC= '21'; q.pattern= '213212' ; ADD(q)
  q.value= 22; q.codeA= '6'   ; q.codeB= '6'    ; q.codeC= '22'; q.pattern= '223112' ; ADD(q)
  q.value= 23; q.codeA= '7'   ; q.codeB= '7'    ; q.codeC= '23'; q.pattern= '312131' ; ADD(q)
  q.value= 24; q.codeA= '8'   ; q.codeB= '8'    ; q.codeC= '24'; q.pattern= '311222' ; ADD(q)
  q.value= 25; q.codeA= '9'   ; q.codeB= '9'    ; q.codeC= '25'; q.pattern= '321122' ; ADD(q)
  q.value= 26; q.codeA= ':'   ; q.codeB= ':'    ; q.codeC= '26'; q.pattern= '321221' ; ADD(q)
  q.value= 27; q.codeA= ';'   ; q.codeB= ';'    ; q.codeC= '27'; q.pattern= '312212' ; ADD(q)
  q.value= 28; q.codeA= '<60>'; q.codeB= '<60>' ; q.codeC= '28'; q.pattern= '322112' ; ADD(q)
  q.value= 29; q.codeA= '='   ; q.codeB= '='    ; q.codeC= '29'; q.pattern= '322211' ; ADD(q)
  q.value= 30; q.codeA= '>'   ; q.codeB= '>'    ; q.codeC= '30'; q.pattern= '212123' ; ADD(q)
  q.value= 31; q.codeA= '?'   ; q.codeB= '?'    ; q.codeC= '31'; q.pattern= '212321' ; ADD(q)
  q.value= 32; q.codeA= '@'   ; q.codeB= '@'    ; q.codeC= '32'; q.pattern= '232121' ; ADD(q)
  q.value= 33; q.codeA= 'A'   ; q.codeB= 'A'    ; q.codeC= '33'; q.pattern= '111323' ; ADD(q)
  q.value= 34; q.codeA= 'B'   ; q.codeB= 'B'    ; q.codeC= '34'; q.pattern= '131123' ; ADD(q)
  q.value= 35; q.codeA= 'C'   ; q.codeB= 'C'    ; q.codeC= '35'; q.pattern= '131321' ; ADD(q)
  q.value= 36; q.codeA= 'D'   ; q.codeB= 'D'    ; q.codeC= '36'; q.pattern= '112313' ; ADD(q)
  q.value= 37; q.codeA= 'E'   ; q.codeB= 'E'    ; q.codeC= '37'; q.pattern= '132113' ; ADD(q)
  q.value= 38; q.codeA= 'F'   ; q.codeB= 'F'    ; q.codeC= '38'; q.pattern= '132311' ; ADD(q)
  q.value= 39; q.codeA= 'G'   ; q.codeB= 'G'    ; q.codeC= '39'; q.pattern= '211313' ; ADD(q)
  q.value= 40; q.codeA= 'H'   ; q.codeB= 'H'    ; q.codeC= '40'; q.pattern= '231113' ; ADD(q)
  q.value= 41; q.codeA= 'I'   ; q.codeB= 'I'    ; q.codeC= '41'; q.pattern= '231311' ; ADD(q)
  q.value= 42; q.codeA= 'J'   ; q.codeB= 'J'    ; q.codeC= '42'; q.pattern= '112133' ; ADD(q)
  q.value= 43; q.codeA= 'K'   ; q.codeB= 'K'    ; q.codeC= '43'; q.pattern= '112331' ; ADD(q)
  q.value= 44; q.codeA= 'L'   ; q.codeB= 'L'    ; q.codeC= '44'; q.pattern= '132131' ; ADD(q)
  q.value= 45; q.codeA= 'M'   ; q.codeB= 'M'    ; q.codeC= '45'; q.pattern= '113123' ; ADD(q)
  q.value= 46; q.codeA= 'N'   ; q.codeB= 'N'    ; q.codeC= '46'; q.pattern= '113321' ; ADD(q)
  q.value= 47; q.codeA= 'O'   ; q.codeB= 'O'    ; q.codeC= '47'; q.pattern= '133121' ; ADD(q)
  q.value= 48; q.codeA= 'P'   ; q.codeB= 'P'    ; q.codeC= '48'; q.pattern= '313121' ; ADD(q)
  q.value= 49; q.codeA= 'Q'   ; q.codeB= 'Q'    ; q.codeC= '49'; q.pattern= '211331' ; ADD(q)
  q.value= 50; q.codeA= 'R'   ; q.codeB= 'R'    ; q.codeC= '50'; q.pattern= '231131' ; ADD(q)
  q.value= 51; q.codeA= 'S'   ; q.codeB= 'S'    ; q.codeC= '51'; q.pattern= '213113' ; ADD(q)
  q.value= 52; q.codeA= 'T'   ; q.codeB= 'T'    ; q.codeC= '52'; q.pattern= '213311' ; ADD(q)
  q.value= 53; q.codeA= 'U'   ; q.codeB= 'U'    ; q.codeC= '53'; q.pattern= '213131' ; ADD(q)
  q.value= 54; q.codeA= 'V'   ; q.codeB= 'V'    ; q.codeC= '54'; q.pattern= '311123' ; ADD(q)
  q.value= 55; q.codeA= 'W'   ; q.codeB= 'W'    ; q.codeC= '55'; q.pattern= '311321' ; ADD(q)
  q.value= 56; q.codeA= 'X'   ; q.codeB= 'X'    ; q.codeC= '56'; q.pattern= '331121' ; ADD(q)
  q.value= 57; q.codeA= 'Y'   ; q.codeB= 'Y'    ; q.codeC= '57'; q.pattern= '312113' ; ADD(q)
  q.value= 58; q.codeA= 'Z'   ; q.codeB= 'Z'    ; q.codeC= '58'; q.pattern= '312311' ; ADD(q)
  q.value= 59; q.codeA= '['   ; q.codeB= '['    ; q.codeC= '59'; q.pattern= '332111' ; ADD(q)
  q.value= 60; q.codeA= '\'   ; q.codeB= '\'    ; q.codeC= '60'; q.pattern= '314111' ; ADD(q)
  q.value= 61; q.codeA= ']'   ; q.codeB= ']'    ; q.codeC= '61'; q.pattern= '221411' ; ADD(q)
  q.value= 62; q.codeA= '^'   ; q.codeB= '^'    ; q.codeC= '62'; q.pattern= '431111' ; ADD(q)
  q.value= 63; q.codeA= '_'   ; q.codeB= '_'    ; q.codeC= '63'; q.pattern= '111224' ; ADD(q)
  q.value= 64; q.codeA= '<0>' ; q.codeB= '`'    ; q.codeC= '64'; q.pattern= '111422' ; ADD(q)
  q.value= 65; q.codeA= '<1>' ; q.codeB= 'a'    ; q.codeC= '65'; q.pattern= '121124' ; ADD(q)
  q.value= 66; q.codeA= '<2>' ; q.codeB= 'b'    ; q.codeC= '66'; q.pattern= '121421' ; ADD(q)
  q.value= 67; q.codeA= '<3>' ; q.codeB= 'c'    ; q.codeC= '67'; q.pattern= '141122' ; ADD(q)
  q.value= 68; q.codeA= '<4>' ; q.codeB= 'd'    ; q.codeC= '68'; q.pattern= '141221' ; ADD(q)
  q.value= 69; q.codeA= '<5>' ; q.codeB= 'e'    ; q.codeC= '69'; q.pattern= '112214' ; ADD(q)
  q.value= 70; q.codeA= '<6>' ; q.codeB= 'f'    ; q.codeC= '70'; q.pattern= '112412' ; ADD(q)
  q.value= 71; q.codeA= '<7>' ; q.codeB= 'g'    ; q.codeC= '71'; q.pattern= '122114' ; ADD(q)
  q.value= 72; q.codeA= '<8>' ; q.codeB= 'h'    ; q.codeC= '72'; q.pattern= '122411' ; ADD(q)
  q.value= 73; q.codeA= '<9>' ; q.codeB= 'i'    ; q.codeC= '73'; q.pattern= '142112' ; ADD(q)
  q.value= 74; q.codeA= '<10>'; q.codeB= 'j'    ; q.codeC= '74'; q.pattern= '142211' ; ADD(q)
  q.value= 75; q.codeA= '<11>'; q.codeB= 'k'    ; q.codeC= '75'; q.pattern= '241211' ; ADD(q)
  q.value= 76; q.codeA= '<12>'; q.codeB= 'l'    ; q.codeC= '76'; q.pattern= '221114' ; ADD(q)
  q.value= 77; q.codeA= '<13>'; q.codeB= 'm'    ; q.codeC= '77'; q.pattern= '413111' ; ADD(q)
  q.value= 78; q.codeA= '<14>'; q.codeB= 'n'    ; q.codeC= '78'; q.pattern= '241112' ; ADD(q)
  q.value= 79; q.codeA= '<15>'; q.codeB= 'o'    ; q.codeC= '79'; q.pattern= '134111' ; ADD(q)
  q.value= 80; q.codeA= '<16>'; q.codeB= 'p'    ; q.codeC= '80'; q.pattern= '111242' ; ADD(q)
  q.value= 81; q.codeA= '<17>'; q.codeB= 'q'    ; q.codeC= '81'; q.pattern= '121142' ; ADD(q)
  q.value= 82; q.codeA= '<18>'; q.codeB= 'r'    ; q.codeC= '82'; q.pattern= '121241' ; ADD(q)
  q.value= 83; q.codeA= '<19>'; q.codeB= 's'    ; q.codeC= '83'; q.pattern= '114212' ; ADD(q)
  q.value= 84; q.codeA= '<20>'; q.codeB= 't'    ; q.codeC= '84'; q.pattern= '124112' ; ADD(q)
  q.value= 85; q.codeA= '<21>'; q.codeB= 'u'    ; q.codeC= '85'; q.pattern= '124211' ; ADD(q)
  q.value= 86; q.codeA= '<22>'; q.codeB= 'v'    ; q.codeC= '86'; q.pattern= '411212' ; ADD(q)
  q.value= 87; q.codeA= '<23>'; q.codeB= 'w'    ; q.codeC= '87'; q.pattern= '421112' ; ADD(q)
  q.value= 88; q.codeA= '<24>'; q.codeB= 'x'    ; q.codeC= '88'; q.pattern= '421211' ; ADD(q)
  q.value= 89; q.codeA= '<25>'; q.codeB= 'y'    ; q.codeC= '89'; q.pattern= '212141' ; ADD(q)
  q.value= 90; q.codeA= '<26>'; q.codeB= 'z'    ; q.codeC= '90'; q.pattern= '214121' ; ADD(q)
  q.value= 91; q.codeA= '<27>'; q.codeB= '{{'   ; q.codeC= '91'; q.pattern= '412121' ; ADD(q)
  q.value= 92; q.codeA= '<28>'; q.codeB= '|'    ; q.codeC= '92'; q.pattern= '111143' ; ADD(q)
  q.value= 93; q.codeA= '<29>'; q.codeB= '}'    ; q.codeC= '93'; q.pattern= '111341' ; ADD(q)
  q.value= 94; q.codeA= '<30>'; q.codeB= '~'    ; q.codeC= '94'; q.pattern= '131141' ; ADD(q)
  q.value= 95; q.codeA= '<31>'; q.codeB= '<127>'; q.codeC= '95'; q.pattern= '114113' ; ADD(q)
  q.value= 96; q.codeA='<203>'; q.codeB='<203>' ; q.codeC= '96'; q.pattern= '114311' ; ADD(q)
  q.value= 97; q.codeA='<202>'; q.codeB='<202>' ; q.codeC= '97'; q.pattern= '411113' ; ADD(q)
  q.value= 98; q.codeA='<240>'; q.codeB='<240>' ; q.codeC= '98'; q.pattern= '411311' ; ADD(q)
  q.value= 99; q.codeA='<243>'; q.codeB='<243>' ; q.codeC= '99'; q.pattern= '113141' ; ADD(q)
  q.value=100; q.codeA='<242>'; q.codeB='<204>' ; q.codeC='<242>'; q.pattern= '114131' ; ADD(q)
  q.value=101; q.codeA='<204>'; q.codeB='<241>' ; q.codeC='<241>'; q.pattern= '311141' ; ADD(q)
  q.value=102; q.codeA='<201>'; q.codeB='<201>' ; q.codeC='<201>'; q.pattern= '411131' ; ADD(q)
  q.value=103; q.codeA='<251>'; q.codeB='<251>' ; q.codeC='<251>'; q.pattern= '211412' ; ADD(q)
  q.value=104; q.codeA='<252>'; q.codeB='<252>' ; q.codeC='<252>'; q.pattern= '211214' ; ADD(q)
  q.value=105; q.codeA='<253>'; q.codeB='<253>' ; q.codeC='<253>'; q.pattern= '211232' ; ADD(q)
  q.value=106; q.codeA='<255>'; q.codeB='<255>' ; q.codeC='<255>'; q.pattern= '2331112'; ADD(q)
  SORT(q,q.codeA)
  SORT(q,q.codeB)
  SORT(q,q.codeC)
  SORT(q,q.value)
!
!
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: UPC_A ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
UPC_A.Draw    PROCEDURE(STRING bc_string)        !Draw UPC_A barcode
!------------------------------------------------------------------------------------------------------------
barCount    SHORT                   !Total numbers of bars to print
bc_pattern  CSTRING(255)
i           SHORT
chkDigit    BYTE

      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed)
   IF LEN(CLIP(bc_string)) = 11
       bc_string = CLIP(bc_string) & '0'                   !Add temporarily a "dummy" check character
       chkDigit = SELF.GetCheckDigit(bc_string)
       bc_string[12] = chkDigit
   ELSIF LEN(CLIP(bc_string)) = 12
       chkDigit = SELF.GetCheckDigit(bc_string)
       IF bc_string[12] <> chkDigit THEN RETURN BCERROR:BadCheckDigit.      !Wrong chkdigit
   ELSE
       RETURN BCERROR:InvalidValue                                          !UPC_A = 12 characters....
   END
   !
   !(3) Before anything, calculate how many BARs we need.  Loop through all characters
   !    in barcode summing into variable "barCount" the total number of bars
   barCount = (12*7) +  |      !Total number of bars +
               3+3+5 +  |      !extra bars +
               SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight

   !zzzzz
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5)  Build pattern string...
   bc_pattern = '101'                              !add left hand bars
   LOOP i=1 TO 12
      IF i <= 6                                    !Left hand characters
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]))
         IF i=6 THEN bc_pattern = bc_pattern & '01010'.
      ELSE                                         !Right hand characters
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]+10))
      END
   END
   bc_pattern = bc_pattern & '101'                 !add right hand bars
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !(7) DRAW BARCODE
   !MESSAGE(bc_pattern)
   LOOP i = 1 TO LEN(bc_pattern)
      !draw each bar
      IF bc_pattern[i] = '1'     !bar
         SELF.DrawBox(1,SELF.myBC.BarColor)
      ELSIF bc_pattern[i] = '0'
         SELF.DrawBox(1,SELF.myBC.BackColor)
      ELSE
         MESSAGE('Error in the draw pattern')
      END
   END
   !
   !
   !(8) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !
   !(9) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN FALSE
!
!
!------------------------------------------------------------------------------------------------------------
UPC_A.GetCheckDigit        PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
odd         LONG(0)
even        LONG(0)
LastPos     BYTE,AUTO
i           BYTE,AUTO
chkDigit    LONG,AUTO
isOdd       BYTE(1)
      CODE
    LastPos = LEN(CLIP(bc_string)) - 1      !e.g. UPC_A: 12-1=11; EAN13: 13-1=12; EAN8: 8-1=7
    LOOP i=LastPos TO 1 BY -1
      IF isOdd
         odd += bc_string[i]
      ELSE
         even += bc_string[i]
      END
      isOdd = BXOR(isOdd,1)
    END
    odd = odd * 3
    chkDigit = 10 - ((odd + even) % 10)
    IF chkDigit = 10 THEN chkDigit = 0.
    RETURN chkDigit
!
!
!------------------------------------------------------------------------------------------------------------
UPC_A.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 0;  q.pattern = '0001101';ADD(q,q.asciiCode)          !Left Hand 0
    q.asciiCode = 1;  q.pattern = '0011001';ADD(q,q.asciiCode)          !Left Hand 1
    q.asciiCode = 2;  q.pattern = '0010011';ADD(q,q.asciiCode)          !Left Hand 2
    q.asciiCode = 3;  q.pattern = '0111101';ADD(q,q.asciiCode)          !Left Hand 3
    q.asciiCode = 4;  q.pattern = '0100011';ADD(q,q.asciiCode)          !Left Hand 4
    q.asciiCode = 5;  q.pattern = '0110001';ADD(q,q.asciiCode)          !Left Hand 5
    q.asciiCode = 6;  q.pattern = '0101111';ADD(q,q.asciiCode)          !Left Hand 6
    q.asciiCode = 7;  q.pattern = '0111011';ADD(q,q.asciiCode)          !Left Hand 7
    q.asciiCode = 8;  q.pattern = '0110111';ADD(q,q.asciiCode)          !Left Hand 8
    q.asciiCode = 9;  q.pattern = '0001011';ADD(q,q.asciiCode)          !Left Hand 9

    q.asciiCode = 10; q.pattern = '1110010';ADD(q,q.asciiCode)          !Right Hand 0
    q.asciiCode = 11; q.pattern = '1100110';ADD(q,q.asciiCode)          !Right Hand 1
    q.asciiCode = 12; q.pattern = '1101100';ADD(q,q.asciiCode)          !Right Hand 2
    q.asciiCode = 13; q.pattern = '1000010';ADD(q,q.asciiCode)          !Right Hand 3
    q.asciiCode = 14; q.pattern = '1011100';ADD(q,q.asciiCode)          !Right Hand 4
    q.asciiCode = 15; q.pattern = '1001110';ADD(q,q.asciiCode)          !Right Hand 5
    q.asciiCode = 16; q.pattern = '1010000';ADD(q,q.asciiCode)          !Right Hand 6
    q.asciiCode = 17; q.pattern = '1000100';ADD(q,q.asciiCode)          !Right Hand 7
    q.asciiCode = 18; q.pattern = '1001000';ADD(q,q.asciiCode)          !Right Hand 8
    q.asciiCode = 19; q.pattern = '1110100';ADD(q,q.asciiCode)          !Right Hand 9
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: UPC_ASUP2 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
UPC_ASUP2.Draw    PROCEDURE(STRING bc_string)        !Draw UPC_A barcode
!------------------------------------------------------------------------------------------------------------
      CODE
      RETURN BCERROR:NoError
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: UPC_ASUP5 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
UPC_ASUP5.Draw    PROCEDURE(STRING bc_string)        !Draw UPC_A barcode
!------------------------------------------------------------------------------------------------------------

      CODE
   RETURN BCERROR:NoError
!
!
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: UPC_E ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
UPC_E.Draw    PROCEDURE(STRING bc_string)        !Draw UPC_E barcode
!------------------------------------------------------------------------------------------------------------
barCount    SHORT                   !Total numbers of bars to print
bc_pattern  CSTRING(255)
i           SHORT
chkDigit    BYTE
numberSystem BYTE
parity      BYTE

      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed) --  Some specifics to the UPC_E
   IF LEN(CLIP(bc_string)) = 11
      bc_string = CLIP(bc_string) & '0'             !Add temporarily a "dummy" check character
      chkDigit = SELF.GetCheckDigit(bc_string)
      bc_string[12] = chkDigit
      numberSystem = bc_string[1]
      bc_string    = SELF.compress(bc_string)       !Compress UPC_A to UPC_E
   ELSIF LEN(CLIP(bc_string)) = 12
      chkDigit = SELF.GetCheckDigit(bc_string)
      IF bc_string[12] <> chkDigit THEN RETURN BCERROR:BadCheckDigit.    !Wrong chkdigit
      numberSystem = bc_string[1]
      bc_string    = SELF.compress(bc_string)      !Compress UPC_A to UPC_E
   ELSIF LEN(CLIP(bc_string)) = 8
      chkDigit = SELF.GetCheckDigit(SELF.Expand(bc_string))
      IF chkDigit <> bc_string[8] THEN RETURN BCERROR:BadCheckDigit.     !Wrong chkdigit
      numberSystem = bc_string[1]
   ELSE                                               !Wrong number of chars...
      RETURN BCERROR:InvalidValue
   END
   IF numberSystem <> 0 AND numberSystem <> 1 THEN RETURN BCERROR:OtherErrors.   !Wrong number system
   !
   !(3) Calculate the bar width
   barCount = (6*7)+  |      !Total number of bars +
               3+6+   |      !extra bars +
               SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5)  Build pattern string...
   bc_pattern = '101'                              !add left hand bars
   LOOP i=2 TO 7
      parity = CHOOSE(numberSystem=0, BAND(UPCE_Enc[chkDigit+1],2^(i-2)),BAND(UPCE_Enc[chkDigit+11],2^(i-2)) )
      IF parity
!?        test" = SELF.getPattern(bc_string[i])
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]))        !Odd parity
      ELSE
!?        test" = SELF.getPattern(bc_string[i]+10)
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]+10))     !Even parity
      END
   END
   bc_pattern = bc_pattern & '010101'              !add right hand bars
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !(7) DRAW BARCODE
   LOOP i = 1 TO LEN(bc_pattern)
      IF bc_pattern[i] = '1'     !bar
         SELF.DrawBox(1,SELF.myBC.BarColor)
      ELSIF bc_pattern[i] = '0'
         SELF.DrawBox(1,SELF.myBC.BackColor)
      ELSE
         MESSAGE('Error in the draw pattern')
      END
   END
   !
   !
   !(8) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !
   !(9) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN BCERROR:NoError
!
!
!
!------------------------------------------------------------------------------------------------------------
UPC_E.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 0;  q.pattern = '0001101';ADD(q,q.asciiCode)          !Odd Parity 0
    q.asciiCode = 1;  q.pattern = '0011001';ADD(q,q.asciiCode)          !Odd Parity 1
    q.asciiCode = 2;  q.pattern = '0010011';ADD(q,q.asciiCode)          !Odd Parity 2
    q.asciiCode = 3;  q.pattern = '0111101';ADD(q,q.asciiCode)          !Odd Parity 3
    q.asciiCode = 4;  q.pattern = '0100011';ADD(q,q.asciiCode)          !Odd Parity 4
    q.asciiCode = 5;  q.pattern = '0110001';ADD(q,q.asciiCode)          !Odd Parity 5
    q.asciiCode = 6;  q.pattern = '0101111';ADD(q,q.asciiCode)          !Odd Parity 6
    q.asciiCode = 7;  q.pattern = '0111011';ADD(q,q.asciiCode)          !Odd Parity 7
    q.asciiCode = 8;  q.pattern = '0110111';ADD(q,q.asciiCode)          !Odd Parity 8
    q.asciiCode = 9;  q.pattern = '0001011';ADD(q,q.asciiCode)          !Odd Parity 9

    q.asciiCode = 10; q.pattern = '0100111';ADD(q,q.asciiCode)          !Even Parity 0
    q.asciiCode = 11; q.pattern = '0110011';ADD(q,q.asciiCode)          !Even Parity 1
    q.asciiCode = 12; q.pattern = '0011011';ADD(q,q.asciiCode)          !Even Parity 2
    q.asciiCode = 13; q.pattern = '0100001';ADD(q,q.asciiCode)          !Even Parity 3
    q.asciiCode = 14; q.pattern = '0011101';ADD(q,q.asciiCode)          !Even Parity 4
    q.asciiCode = 15; q.pattern = '0111001';ADD(q,q.asciiCode)          !Even Parity 5
    q.asciiCode = 16; q.pattern = '0000101';ADD(q,q.asciiCode)          !Even Parity 6
    q.asciiCode = 17; q.pattern = '0010001';ADD(q,q.asciiCode)          !Even Parity 7
    q.asciiCode = 18; q.pattern = '0001001';ADD(q,q.asciiCode)          !Even Parity 8
    q.asciiCode = 19; q.pattern = '0010111';ADD(q,q.asciiCode)          !Even Parity 9
!
!
!------------------------------------------------------------------------------------------------------------
UPC_E.Compress             PROCEDURE(STRING bc)
!------------------------------------------------------------------------------------------------------------
bc_string      STRING(8)
manufacturer   STRING(5)
itemNumber     LONG
          CODE
    manufacturer = bc[2 : 6]
    itemNumber   = bc[7 : 11]
    IF manufacturer[3:5] = '000' OR manufacturer[3:5] = '100' OR manufacturer[3:5] = '200'
       IF itemNumber > 999 THEN RETURN ''.      !Invalid
       bc_string = bc[2 : 3] & bc[9:11] & bc[4]
    ELSIF manufacturer[3:5] = '300' OR manufacturer[3:5] = '400' OR manufacturer[3:5] = '500' OR |
          manufacturer[3:5] = '600' OR manufacturer[3:5] = '700' OR manufacturer[3:5] = '800' OR |
          manufacturer[3:5] = '900'
       IF itemNumber > 99 THEN RETURN ''.      !Invalid
       bc_string = bc[2 : 4] & bc[10:11] & '3'
    ELSIF manufacturer[4:5] = '10' OR manufacturer[4:5] = '20' OR manufacturer[4:5] = '30' OR |
          manufacturer[4:5] = '40' OR manufacturer[4:5] = '50' OR manufacturer[4:5] = '60' OR |
          manufacturer[4:5] = '70' OR manufacturer[4:5] = '80' OR manufacturer[4:5] = '90'
       IF itemNumber > 9 THEN RETURN ''.      !Invalid
       bc_string = bc[2 : 5] & bc[11] & '4'
    ELSIF manufacturer[5] <> '0'
       IF itemNumber < 5 AND itemNumber > 9 THEN RETURN ''.      !Invalid
       bc_string = bc[2 : 6] & bc[11]
    END
    bc_string = bc[1] & CLIP(bc_string) & bc[12]
    RETURN(bc_string)
!
!
!------------------------------------------------------------------------------------------------------------
UPC_E.Expand               PROCEDURE(STRING bc)
!------------------------------------------------------------------------------------------------------------
bc_string      STRING(12)
manufacturer   STRING(5)
itemNumber     STRING(5)

! 1 234567 8
          CODE
    IF bc[7] = '0' OR bc[7] = '1'
       manufacturer = bc[2 : 3] & bc[7] & '00'
       itemNumber   = FORMAT(bc[4:6],@n05)
    ELSIF bc[7] = '3'
       manufacturer = bc[2 : 4] & '00'
       itemNumber   = FORMAT(bc[5:6],@n05)
    ELSIF bc[7] = '4'
       manufacturer = bc[2 : 5] & '0'
       itemNumber   = FORMAT(bc[6],@n05)
    ELSE
       manufacturer = bc[2 : 6]
       itemNumber   = FORMAT(bc[7],@n05)
    END
    bc_string = bc[1] & manufacturer & itemNumber & bc[8]
    RETURN(bc_string)
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: EAN13 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
EAN13.Draw    PROCEDURE(STRING bc_string)        !Draw EAN13 barcode
!------------------------------------------------------------------------------------------------------------
barCount    SHORT                   !Total numbers of bars to print
bc_pattern  CSTRING(255)
i           SHORT
c           SHORT
chkDigit    BYTE

      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed)
   IF LEN(CLIP(bc_string)) = 12                             !Didn't send the the check digit
       bc_string = CLIP(bc_string) & '0'                    !..Add temporarily a "dummy" check character
       chkDigit = SELF.GetCheckDigit(bc_string)             !..get the check digit,
       bc_string[13] = chkDigit                             !..and add it.
   ELSIF LEN(CLIP(bc_string)) = 13
       chkDigit = SELF.GetCheckDigit(bc_string)
       IF bc_string[13] <> chkDigit THEN RETURN BCERROR:BadCheckDigit.      !Wrong chkdigit
   ELSE
       RETURN BCERROR:InvalidValue                                          !EAN13 = 13 characters....
   END
   !
   !(3) Calculate the bar width
   barCount = (12*7) +  |     !Total number of bars +
                 11  +  |     !extra bars +
               SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5)  Build pattern string...
   bc_pattern = '101'                                                      !add left hand bars
   c = bc_string[1]+1
   c = EAN13Enc[c]
   LOOP i=2 TO 13
      IF i=2
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]))     !As a LeftHand "A"
      ELSIF i <= 7
         IF BAND(c,2^(i-3))      !1 = LeftHand "B"
            bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]+10))
         ELSE                    !0 = LeftHand "A"
            bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]))
         END
         IF i=7 THEN bc_pattern = bc_pattern & '01010'.
      ELSE                                                                 !Right hand characters
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]+20))
      END
   END
   bc_pattern = bc_pattern & '101'                 !add right hand bars
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !(7) DRAW BARCODE
   LOOP i = 1 TO LEN(bc_pattern)
      !draw each bar
      IF bc_pattern[i] = '1'     !bar
         SELF.DrawBox(1,SELF.myBC.BarColor)
      ELSIF bc_pattern[i] = '0'
         SELF.DrawBox(1,SELF.myBC.BackColor)
      ELSE
         MESSAGE('Error in the draw pattern')
      END
   END
   !
   !
   !(8) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !
   !(9) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN BCError:NoError
!
!
!------------------------------------------------------------------------------------------------------------
EAN13.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 0;  q.pattern = '0001101';ADD(q,q.asciiCode)          !Left Hand A 0
    q.asciiCode = 1;  q.pattern = '0011001';ADD(q,q.asciiCode)          !Left Hand A 1
    q.asciiCode = 2;  q.pattern = '0010011';ADD(q,q.asciiCode)          !Left Hand A 2
    q.asciiCode = 3;  q.pattern = '0111101';ADD(q,q.asciiCode)          !Left Hand A 3
    q.asciiCode = 4;  q.pattern = '0100011';ADD(q,q.asciiCode)          !Left Hand A 4
    q.asciiCode = 5;  q.pattern = '0110001';ADD(q,q.asciiCode)          !Left Hand A 5
    q.asciiCode = 6;  q.pattern = '0101111';ADD(q,q.asciiCode)          !Left Hand A 6
    q.asciiCode = 7;  q.pattern = '0111011';ADD(q,q.asciiCode)          !Left Hand A 7
    q.asciiCode = 8;  q.pattern = '0110111';ADD(q,q.asciiCode)          !Left Hand A 8
    q.asciiCode = 9;  q.pattern = '0001011';ADD(q,q.asciiCode)          !Left Hand A 9

    q.asciiCode = 10; q.pattern = '0100111';ADD(q,q.asciiCode)          !Left Hand B 0
    q.asciiCode = 11; q.pattern = '0110011';ADD(q,q.asciiCode)          !Left Hand B 1
    q.asciiCode = 12; q.pattern = '0011011';ADD(q,q.asciiCode)          !Left Hand B 2
    q.asciiCode = 13; q.pattern = '0100001';ADD(q,q.asciiCode)          !Left Hand B 3
    q.asciiCode = 14; q.pattern = '0011101';ADD(q,q.asciiCode)          !Left Hand B 4
    q.asciiCode = 15; q.pattern = '0111001';ADD(q,q.asciiCode)          !Left Hand B 5
    q.asciiCode = 16; q.pattern = '0000101';ADD(q,q.asciiCode)          !Left Hand B 6
    q.asciiCode = 17; q.pattern = '0010001';ADD(q,q.asciiCode)          !Left Hand B 7
    q.asciiCode = 18; q.pattern = '0001001';ADD(q,q.asciiCode)          !Left Hand B 8
    q.asciiCode = 19; q.pattern = '0010111';ADD(q,q.asciiCode)          !Left Hand B 9

    q.asciiCode = 20; q.pattern = '1110010';ADD(q,q.asciiCode)          !Right Hand 0
    q.asciiCode = 21; q.pattern = '1100110';ADD(q,q.asciiCode)          !Right Hand 1
    q.asciiCode = 22; q.pattern = '1101100';ADD(q,q.asciiCode)          !Right Hand 2
    q.asciiCode = 23; q.pattern = '1000010';ADD(q,q.asciiCode)          !Right Hand 3
    q.asciiCode = 24; q.pattern = '1011100';ADD(q,q.asciiCode)          !Right Hand 4
    q.asciiCode = 25; q.pattern = '1001110';ADD(q,q.asciiCode)          !Right Hand 5
    q.asciiCode = 26; q.pattern = '1010000';ADD(q,q.asciiCode)          !Right Hand 6
    q.asciiCode = 27; q.pattern = '1000100';ADD(q,q.asciiCode)          !Right Hand 7
    q.asciiCode = 28; q.pattern = '1001000';ADD(q,q.asciiCode)          !Right Hand 8
    q.asciiCode = 29; q.pattern = '1110100';ADD(q,q.asciiCode)          !Right Hand 9
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: EAN8 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
EAN8.Draw    PROCEDURE(STRING bc_string)        !Draw EAN8 barcode
!------------------------------------------------------------------------------------------------------------
barCount    SHORT                   !Total numbers of bars to print
bc_pattern  CSTRING(255)
i           SHORT
chkDigit    BYTE

      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed) --  Some specifics to the UPC_E
   IF LEN(CLIP(bc_string)) = 7                              !Didn't send the the check digit
       bc_string = CLIP(bc_string) & '0'                    !..Add temporarily a "dummy" check character
       chkDigit = SELF.GetCheckDigit(bc_string)             !..get the check digit,
       bc_string[8] = chkDigit                              !..and add it.
   ELSIF LEN(CLIP(bc_string)) = 8
       chkDigit = SELF.GetCheckDigit(bc_string)
       IF bc_string[8] <> chkDigit THEN RETURN BCERROR:BadCheckDigit.       !Wrong chkdigit
   ELSE
       RETURN BCERROR:InvalidValue                                          !EAN8 = 8 characters....
   END
   !
   !(3) Calculate the bar width
   barCount = (8*7) +  |      !Total number of bars +
                 11 +  |      !extra bars +
               SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5)  Build pattern string...
   bc_pattern = '101'                                                      !add left hand bars
   LOOP i=1 TO 8
      IF i<=4                                                              !Two flag chars + first two data
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]))     !..as a LeftHand "A"
         IF i=4 THEN bc_pattern = bc_pattern & '01010'.
      ELSE                                                                 !Last three data + check
         bc_pattern = bc_pattern & CLIP(SELF.getPattern(bc_string[i]+20))  !..as RightHand characters
      END
   END
   bc_pattern = bc_pattern & '101'                                         !add right hand bars
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      SELF.DrawBOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !(7) DRAW BARCODE
   LOOP i = 1 TO LEN(bc_pattern)
      !draw each bar
      IF bc_pattern[i] = '1'     !bar
         SELF.DrawBox(1,SELF.myBC.BarColor)
      ELSIF bc_pattern[i] = '0'
         SELF.DrawBox(1,SELF.myBC.BackColor)
      ELSE
         MESSAGE('Error in the draw pattern')
      END
   END
   !
   !
   !(8) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !
   !(9) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN BCERROR:NoError
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: INTERLEAVED 2 OF 5 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
INT2of5.Draw    PROCEDURE(STRING bc_string)        !Draw INTERLEAVED2of5 barcode
!------------------------------------------------------------------------------------------------------------
narrowCount SHORT
barCount    REAL
wideCount   SHORT
bc_pattern  CSTRING(255)
barPattern  CSTRING(10)
spacePattern CSTRING(10)
n           SHORT
c           BYTE
i           SHORT
j           SHORT
isBar       BYTE
      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed)
   n = LEN(CLIP(bc_string)) + CHOOSE(SELF.myBC.AddCheckDigit,1,0)
   IF n%2                           !not even?
      bc_string = '0' & bc_string   !..make it an even number of digits
      n += 1
   END
   !
   !
   !(3) Calculate the bar width
   narrowCount = 3 * n +  |                                 !Total of narrow bars/spaces +
                 4 + 2 +  |                                 !..start + stop +
              SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight      !..QUIET ZONES...
   wideCount   = 2 * n + |                                  !Total of wide bars/spaces +
                 1
   barCount    = narrowCount + wideCount * SELF.myBC.Wide2NarrowRatio
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5)  Build pattern string...
   IF SELF.myBC.AddCheckDigit          !If using check digit, add it now...
      bc_string = CLIP(bc_string) & CHR(SELF.GetCheckDigit(bc_string))
   END
   bc_pattern = '0000'                                                     !add "start" bars
   LOOP i=1 TO LEN(CLIP(bc_string))
      barPattern   = SELF.getPattern(VAL(bc_string[i]))
      spacePattern = SELF.getPattern(VAL(bc_string[i+1]))
      LOOP j=1 TO 5
         bc_pattern = bc_pattern & barPattern[j] & spacePattern[j]         !interleave digits
      END
      i += 1
   END
   bc_pattern = bc_pattern & '100'                                         !add end bars
   !
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !
   !(7) DRAW BARCODE
   isBar = TRUE      !Start with a bar...
   LOOP i = 1 TO LEN(bc_pattern)
      IF bc_pattern[i] = '1'     !WIDE
         SELF.DrawBox(SELF.myBC.Wide2NarrowRatio,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
      ELSE                       !NARROW
         SELF.DrawBox(1,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
      END
      isBar = BXOR(isBar,1)
   END
   !
   !
   !(8) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !
   !(9) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN BCError:NoError
!
!
!
!------------------------------------------------------------------------------------------------------------
INT2of5.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 48; q.pattern = '00110';ADD(q,q.asciiCode)        !0
    q.asciiCode = 49; q.pattern = '10001';ADD(q,q.asciiCode)        !1
    q.asciiCode = 50; q.pattern = '01001';ADD(q,q.asciiCode)        !2
    q.asciiCode = 51; q.pattern = '11000';ADD(q,q.asciiCode)        !3
    q.asciiCode = 52; q.pattern = '00101';ADD(q,q.asciiCode)        !4
    q.asciiCode = 53; q.pattern = '10100';ADD(q,q.asciiCode)        !5
    q.asciiCode = 54; q.pattern = '01100';ADD(q,q.asciiCode)        !6
    q.asciiCode = 55; q.pattern = '00011';ADD(q,q.asciiCode)        !7
    q.asciiCode = 56; q.pattern = '10010';ADD(q,q.asciiCode)        !8
    q.asciiCode = 57; q.pattern = '01010';ADD(q,q.asciiCode)        !9
                                                                                       !capital letters
!
!
!------------------------------------------------------------------------------------------------------------
INT2of5.GetCheckDigit      PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
odd         LONG
even        LONG
LastPos     BYTE
i           BYTE
j           BYTE
chkDigit    LONG
      CODE
    LastPos = LEN(CLIP(bc_string))       !Last one is ALWAYS EVEN
    LOOP i=LastPos-1 TO 1 BY -2
      odd += bc_string[i]
      j = i
    END
    j = CHOOSE(j=1,2,1)
    LOOP i=j TO LastPos BY 2
      even += bc_string[i]
    END
    even = even * 3
    chkDigit = 10 - ((odd + even) % 10)
    IF chkDigit = 10 THEN chkDigit = 0.
    RETURN chkDigit
!
!
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: CODE 2 OF 5 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
CODE2of5.Draw    PROCEDURE(STRING bc_string)        !Draw CODE 2of5 barcode
!------------------------------------------------------------------------------------------------------------
narrowCount SHORT
wideCount   SHORT
barCount    REAL
bc_pattern  CSTRING(255)
barPattern  CSTRING(10)
spacePattern CSTRING(10)
n           SHORT
c           BYTE
i           SHORT
j           SHORT
      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed)
   n = LEN(CLIP(bc_string)) + CHOOSE(SELF.myBC.AddCheckDigit,1,0)
   !
   !
   !(3) Calculate the bar width
   narrowCount = 3 * n +  |                                 !Total of narrow bars/spaces +
                 5 * n +  |                                 !..total of spaces
                 8 + 4 +  |                                 !..start + stop +
              SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight      !..QUIET ZONES...
   wideCount   = 2 * n + |                                  !Total of wide bars/spaces +
                 1
   barCount    = narrowCount + wideCount * SELF.myBC.Wide2NarrowRatio
   !
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5)  Build pattern string...
   IF SELF.myBC.AddCheckDigit          !If using check digit, add it now...
      bc_string = CLIP(bc_string) & CHR(SELF.GetCheckDigit(bc_string))
   END
   bc_pattern = '0000'                                                     !add "start" bars
   LOOP i=1 TO LEN(CLIP(bc_string))
      barPattern   = SELF.getPattern(VAL(bc_string[i]))
      spacePattern = SELF.getPattern(VAL(bc_string[i+1]))
      LOOP j=1 TO 5
         bc_pattern = bc_pattern & barPattern[j] & spacePattern[j]         !interleave digits
      END
      i += 1
   END
   bc_pattern = bc_pattern & '100'                                         !add end bars
   !
   !
   !(6) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !
   !(7) DRAW BARCODE
   LOOP i = 1 TO LEN(bc_pattern)
      IF bc_pattern[i] = '1'     !WIDE bar + space
         SELF.DrawBox(SELF.myBC.Wide2NarrowRatio,SELF.myBC.BarColor)
         SELF.DrawBox(1,SELF.myBC.BackColor)
      ELSE                       !NARROW bar + space
         SELF.DrawBox(1,SELF.myBC.BarColor)
         SELF.DrawBox(1,SELF.myBC.BackColor)
      END
   END
   !
   !
   !(8) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !
   !(9) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN BCError:NoError
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: CODABAR ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
Codabar.Draw    PROCEDURE(STRING bc_string)        !Draw CODABAR barcode
!------------------------------------------------------------------------------------------------------------
narrowCount SHORT
wideCount   SHORT
barCount    REAL
bc_pattern  CSTRING(255)
n           SHORT
c           BYTE
i           SHORT
j           SHORT
isBar       BYTE
      CODE
   !
   !(1) Initialize the control
   SETTARGET(SELF.myBC.myWindow,SELF.myBC.myBand)
   SELF.myBC.SetUnit(TRUE)
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.Width,SELF.myBC.Height)
   !
   !(2) Preprocess and verify the string (if needed)
   bc_string = UPPER(bc_string)
   IF SELF.myBC.AddCheckDigit
      bc_string = bc_string[1 : LEN(CLIP(bc_string))-1] & CHR(SELF.GetCheckDigit(bc_string)) & bc_string[LEN(CLIP(bc_string))]
   END
   !
   !
   !(3)  Build pattern string and calculate the bar width...
   LOOP i=1 TO LEN(CLIP(bc_string))
      bc_pattern = bc_pattern & CLIP(SELF.getPattern(VAL(bc_string[i])))
   END
   narrowCount=0
   wideCount=0
   LOOP i=1 TO LEN(CLIP(bc_pattern))
      IF bc_pattern[i] = '0'
         narrowCount += 1
      ELSE
         wideCount   += 1
      END
   END
   narrowCount += SELF.myBC.ClearAreaLeft + SELF.myBC.ClearAreaRight      !..QUIET ZONES (if any)...
   barCount = narrowCount + wideCount * SELF.myBC.Wide2NarrowRatio
   !
   !
   !(4) Calculate the bar dimensions
   SELF.SetDimensions(bc_string,barCount)
   !
   !
   !(5) Blank the barcode area and optionally draw an enclosing box...
   BLANK(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height})
   IF SELF.myBC.BackColor <> COLOR:None
      SETPENCOLOR(SELF.myBC.BackColor)
      BOX(SELF.myBC.obj{PROP:XPos},SELF.myBC.obj{PROP:YPos},SELF.myBC.obj{PROP:Width},SELF.myBC.obj{PROP:Height},SELF.myBC.BackColor)
   END
   !
   !
   !(6) DRAW BARCODE
   isBar = TRUE      !Start with a bar...
   LOOP i = 1 TO LEN(bc_pattern)
      IF bc_pattern[i] = '1'     !WIDE
         SELF.DrawBox(SELF.myBC.Wide2NarrowRatio,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
      ELSE                       !NARROW
         SELF.DrawBox(1,CHOOSE(isBar,SELF.myBC.BarColor,SELF.myBC.BackColor))
      END
      isBar = BXOR(isBar,1)
   END
   !
   !
   !(7) Now draw -if desired- the barcode value
   IF SELF.myBC.DrawText
       SELF.DrawText(bc_string,SELF.tw,SELF.th)
   END
   !
   !
   !(8) Restore everything before we go
   SELF.myBC.SetUnit(FALSE)
   SETTARGET
   RETURN BCError:NoError
!
!
!
!
!------------------------------------------------------------------------------------------------------------
Codabar.GetCheckDigit        PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
LastPos     BYTE,AUTO
i           LONG,AUTO
j           LONG,AUTO
sum         LONG,AUTO
      CODE
    sum = 0
    LastPos = LEN(CLIP(bc_string))
    LOOP i=1 TO LastPos
      SELF.patternQ.asciiCode = VAL(bc_string[i])
      GET(SELF.patternQ,SELF.patternQ.AsciiCode)
      IF ERRORCODE() THEN CYCLE.
      sum += SELF.patternQ.value
    END
    i = sum % 16
    IF i
      i = sum/16
      j = (i+1)*16 - sum
    ELSE
      i = sum/16
      j = i*16 - sum
    END
    SELF.patternQ.value = j
    GET(SELF.patternQ,SELF.patternQ.value)
    IF ERRORCODE() THEN RETURN(0).
    RETURN SELF.patternQ.asciicode
!
!
!
!------------------------------------------------------------------------------------------------------------
Codabar.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 48       ; q.pattern = '0000011';q.value = 0; ADD(q,q.asciiCode)        !0
    q.asciiCode = 49       ; q.pattern = '0000110';q.value = 1; ADD(q,q.asciiCode)        !1
    q.asciiCode = 50       ; q.pattern = '0001001';q.value = 2; ADD(q,q.asciiCode)        !2
    q.asciiCode = 51       ; q.pattern = '1100000';q.value = 3; ADD(q,q.asciiCode)        !3
    q.asciiCode = 52       ; q.pattern = '0010010';q.value = 4; ADD(q,q.asciiCode)        !4
    q.asciiCode = 53       ; q.pattern = '1000010';q.value = 5; ADD(q,q.asciiCode)        !5
    q.asciiCode = 54       ; q.pattern = '0100001';q.value = 6; ADD(q,q.asciiCode)        !6
    q.asciiCode = 55       ; q.pattern = '0100100';q.value = 7; ADD(q,q.asciiCode)        !7
    q.asciiCode = 56       ; q.pattern = '0110000';q.value = 8; ADD(q,q.asciiCode)        !8
    q.asciiCode = 57       ; q.pattern = '1001000';q.value = 9; ADD(q,q.asciiCode)        !9
    q.asciiCode = VAL('-') ; q.pattern = '0001100';q.value =10; ADD(q,q.asciiCode)
    q.asciiCode = VAL('$') ; q.pattern = '0011000';q.value =11; ADD(q,q.asciiCode)
    q.asciiCode = VAL(':') ; q.pattern = '1000101';q.value =12; ADD(q,q.asciiCode)
    q.asciiCode = VAL('/') ; q.pattern = '1010001';q.value =12; ADD(q,q.asciiCode)
    q.asciiCode = VAL('.') ; q.pattern = '1010100';q.value =14; ADD(q,q.asciiCode)
    q.asciiCode = VAL('+') ; q.pattern = '0010101';q.value =15; ADD(q,q.asciiCode)
    q.asciiCode = VAL('A') ; q.pattern = '0011010';q.value =16; ADD(q,q.asciiCode)
    q.asciiCode = VAL('B') ; q.pattern = '0101001';q.value =17; ADD(q,q.asciiCode)
    q.asciiCode = VAL('C') ; q.pattern = '0001011';q.value =18; ADD(q,q.asciiCode)
    q.asciiCode = VAL('D') ; q.pattern = '0001110';q.value =19; ADD(q,q.asciiCode)
    SORT(q,q.value)
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: CODE93 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
CODE93.Draw    PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
   CODE
   RETURN 0
!
!
!
!------------------------------------------------------------------------------------------------------------
CODE93.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
!
!
!------------------------------------------------------------------------------------------------------------
CODE93.GetCheckDigit        PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
chkDigit    LONG
      CODE
    RETURN chkDigit
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: CODE11 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
CODE11.Draw    PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
   CODE
   RETURN 0
!
!
!
!------------------------------------------------------------------------------------------------------------
CODE11.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 48       ; q.pattern = '00001'; q.value=0; ADD(q,q.asciiCode)        !0
    q.asciiCode = 49       ; q.pattern = '10001'; q.value=1; ADD(q,q.asciiCode)        !1
    q.asciiCode = 50       ; q.pattern = '01001'; q.value=2; ADD(q,q.asciiCode)        !2
    q.asciiCode = 51       ; q.pattern = '11000'; q.value=3; ADD(q,q.asciiCode)        !3
    q.asciiCode = 52       ; q.pattern = '00101'; q.value=4; ADD(q,q.asciiCode)        !4
    q.asciiCode = 53       ; q.pattern = '10100'; q.value=5; ADD(q,q.asciiCode)        !5
    q.asciiCode = 54       ; q.pattern = '01100'; q.value=6; ADD(q,q.asciiCode)        !6
    q.asciiCode = 55       ; q.pattern = '00011'; q.value=7; ADD(q,q.asciiCode)        !7
    q.asciiCode = 56       ; q.pattern = '10010'; q.value=8; ADD(q,q.asciiCode)        !8
    q.asciiCode = 57       ; q.pattern = '10000'; q.value=9; ADD(q,q.asciiCode)        !9
    q.asciiCode = VAL('-') ; q.pattern = '00100'; q.value=10;ADD(q,q.asciiCode)
    q.asciiCode = 0        ; q.pattern = '00110'; q.value=10;ADD(q,q.asciiCode)        !Start/Stop
!
!
!------------------------------------------------------------------------------------------------------------
CODE11.GetCheckDigit        PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
chkDigit    LONG
      CODE
    RETURN chkDigit
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: MSI ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
MSI.Draw    PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
   CODE
   RETURN 0
!
!
!
!------------------------------------------------------------------------------------------------------------
MSI.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
    q.asciiCode = 48       ; q.pattern = '0000'; q.value=0; ADD(q,q.asciiCode)        !0
    q.asciiCode = 49       ; q.pattern = '0001'; q.value=1; ADD(q,q.asciiCode)        !1
    q.asciiCode = 50       ; q.pattern = '0010'; q.value=2; ADD(q,q.asciiCode)        !2
    q.asciiCode = 51       ; q.pattern = '0011'; q.value=3; ADD(q,q.asciiCode)        !3
    q.asciiCode = 52       ; q.pattern = '0100'; q.value=4; ADD(q,q.asciiCode)        !4
    q.asciiCode = 53       ; q.pattern = '0101'; q.value=5; ADD(q,q.asciiCode)        !5
    q.asciiCode = 54       ; q.pattern = '0110'; q.value=6; ADD(q,q.asciiCode)        !6
    q.asciiCode = 55       ; q.pattern = '0111'; q.value=7; ADD(q,q.asciiCode)        !7
    q.asciiCode = 56       ; q.pattern = '1000'; q.value=8; ADD(q,q.asciiCode)        !8
    q.asciiCode = 57       ; q.pattern = '1001'; q.value=9; ADD(q,q.asciiCode)        !9
!
!
!------------------------------------------------------------------------------------------------------------
MSI.GetCheckDigit        PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
chkDigit    LONG
      CODE
    RETURN chkDigit
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: POSTNET ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
POSTNET.Draw    PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
   CODE
   RETURN 0
!
!
!
!------------------------------------------------------------------------------------------------------------
POSTNET.SetPatterns          PROCEDURE
!------------------------------------------------------------------------------------------------------------
q           &patternQ:TYPE
        CODE
    q &= SELF.patternQ
    IF RECORDS(q) THEN FREE(q).
!
!
!------------------------------------------------------------------------------------------------------------
POSTNET.GetCheckDigit        PROCEDURE(STRING bc_string)
!------------------------------------------------------------------------------------------------------------
chkDigit    LONG
      CODE
    RETURN chkDigit
!
!
!
!
!
!
!
!
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::: HELPER FUNCTIONS :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!------------------------------------------------------------------------------------------------------------
GetTextProp       PROCEDURE(BCTypeClass SELF,STRING theValue, *UNSIGNED th, *UNSIGNED tw)
!------------------------------------------------------------------------------------------------------------
feq             UNSIGNED
            CODE
   IF SELF.myBC.myBand
      feq = CREATE(0,CREATE:STRING,SELF.myBC.myBand)
   ELSE
      feq = CREATE(0,CREATE:STRING)
   END
   UNHIDE(feq)
   feq{PROP:Text} = CLIP(theValue)
   SETFONT(feq,SELF.myBC.myFont,SELF.myBC.myFontSize,,SELF.myBC.myFontStyle)
   th = feq{PROP:Height}                   !text height
   tw = feq{PROP:Width}                    !text width
   DESTROY(feq)
